;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module _fsmul
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl ___fsmul
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
;../_fsmul.c:241: float __fsmul (float a1, float a2) {
;	---------------------------------
; Function __fsmul
; ---------------------------------
___fsmul::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-20
	add	hl, sp
	ld	sp, hl
;../_fsmul.c:247: fl1.f = a1;
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	hl, #0x0018
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../_fsmul.c:248: fl2.f = a2;
	ld	hl, #4
	add	hl, sp
	ex	de, hl
	ld	hl, #0x001c
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../_fsmul.c:250: if (!fl1.l || !fl2.l)
	ld	hl, #0
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	or	a, b
	or	a, c
	jr	Z,00101$
	ld	hl, #4
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	a, (hl)
	inc	hl
	or	a, (hl)
	or	a, b
	or	a, c
	jr	NZ,00102$
00101$:
;../_fsmul.c:251: return (0);
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00113$
00102$:
;../_fsmul.c:254: sign = SIGN (fl1.l) ^ SIGN (fl2.l);
	ld	hl, #0
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	a, (hl)
	rlc	a
	and	a, #0x01
	ld	-1 (ix), a
	ld	hl, #4
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	a, (hl)
	rlc	a
	and	a, #0x01
	xor	a, -1 (ix)
	ld	c, a
;../_fsmul.c:255: exp = EXP (fl1.l) - EXCESS;
	ld	hl, #0
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	inc	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	ld	h, a
	ld	b, #0x17
00149$:
	srl	h
	rr	l
	rr	d
	rr	e
	djnz	00149$
	ld	b, #0x00
	ld	a, e
	add	a, #0x82
	ld	-2 (ix), a
	ld	a, b
	adc	a, #0xff
	ld	-1 (ix), a
;../_fsmul.c:256: exp += EXP (fl2.l);
	ld	hl, #4
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	inc	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	ld	h, a
	ld	b, #0x17
00151$:
	srl	h
	rr	l
	rr	d
	rr	e
	djnz	00151$
	ld	d, #0x00
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, de
	ld	-2 (ix), l
	ld	-1 (ix), h
;../_fsmul.c:258: fl1.l = MANT (fl1.l);
	ld	hl, #0
	add	hl, sp
	ld	-12 (ix), l
	ld	-11 (ix), h
	ld	hl, #0
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	inc	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	res	7, l
	ld	b, #0x00
	ld	-10 (ix), e
	ld	-9 (ix), d
	ld	a, l
	or	a, #0x80
	ld	-8 (ix), a
	ld	-7 (ix), b
	push	bc
	ld	e, -12 (ix)
	ld	d, -11 (ix)
	ld	hl, #0x000c
	add	hl, sp
	ld	bc, #0x0004
	ldir
	pop	bc
;../_fsmul.c:259: fl2.l = MANT (fl2.l);
	ld	hl, #4
	add	hl, sp
	ld	-12 (ix), l
	ld	-11 (ix), h
	ld	hl, #4
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	inc	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	res	7, l
	ld	b, #0x00
	ld	-10 (ix), e
	ld	-9 (ix), d
	ld	a, l
	or	a, #0x80
	ld	-8 (ix), a
	ld	-7 (ix), b
	push	bc
	ld	e, -12 (ix)
	ld	d, -11 (ix)
	ld	hl, #0x000c
	add	hl, sp
	ld	bc, #0x0004
	ldir
	pop	bc
;../_fsmul.c:262: result = (unsigned long)((unsigned short)(fl1.l >> 8)) * (unsigned short)(fl2.l >> 8);
	ld	hl, #0
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	inc	hl
	ld	a, (hl)
	dec	hl
	ld	h, (hl)
	ld	-10 (ix), d
	ld	-9 (ix), h
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x00
	ld	hl,#4+1+1
	add	hl,sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	dec	hl
	dec	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	ld	h, a
	ld	d, e
	ld	e, h
	ld	hl, #0x0000
	push	bc
	push	hl
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
;../_fsmul.c:263: result += ((unsigned long)((unsigned short)(fl1.l & 0xff)) * (unsigned short)(fl2.l >> 8)) >> 8;
	ld	hl, #0
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	a, (hl)
	ld	d, #0x00
	ld	-10 (ix), e
	ld	-9 (ix), d
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x00
	ld	hl,#4+1+1
	add	hl,sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	dec	hl
	dec	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	ld	h, a
	ld	d, e
	ld	e, h
	ld	hl, #0x0000
	push	bc
	push	hl
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-10 (ix), h
	ld	-9 (ix), e
	ld	-8 (ix), d
	ld	-7 (ix), #0x00
	ld	a, -6 (ix)
	add	a, -10 (ix)
	ld	-6 (ix), a
	ld	a, -5 (ix)
	adc	a, -9 (ix)
	ld	-5 (ix), a
	ld	a, -4 (ix)
	adc	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, -3 (ix)
	adc	a, -7 (ix)
	ld	-3 (ix), a
;../_fsmul.c:264: result += ((unsigned long)((unsigned short)(fl2.l & 0xff)) * (unsigned short)(fl1.l >> 8)) >> 8;
	ld	hl, #4
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	a, (hl)
	ld	d, #0x00
	ld	-10 (ix), e
	ld	-9 (ix), d
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x00
	ld	hl,#0+1+1
	add	hl,sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	dec	hl
	dec	hl
	ld	a, (hl)
	dec	hl
	ld	l, (hl)
	ld	h, a
	ld	d, e
	ld	e, h
	ld	hl, #0x0000
	push	bc
	push	hl
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-10 (ix), h
	ld	-9 (ix), e
	ld	-8 (ix), d
	ld	-7 (ix), #0x00
	ld	a, -6 (ix)
	add	a, -10 (ix)
	ld	-6 (ix), a
	ld	a, -5 (ix)
	adc	a, -9 (ix)
	ld	-5 (ix), a
	ld	a, -4 (ix)
	adc	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, -3 (ix)
	adc	a, -7 (ix)
	ld	-3 (ix), a
;../_fsmul.c:267: result += 0x40;
	ld	a, -6 (ix)
	add	a, #0x40
	ld	-6 (ix), a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	-4 (ix), a
	jr	NC,00165$
	inc	-3 (ix)
00165$:
;../_fsmul.c:269: if (result & SIGNBIT)
	bit	7, -3 (ix)
	jr	Z,00105$
;../_fsmul.c:272: result += 0x40;
	ld	a, -6 (ix)
	add	a, #0x40
	ld	-6 (ix), a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	-5 (ix), a
	ld	a, -4 (ix)
	adc	a, #0x00
	ld	-4 (ix), a
	jr	NC,00167$
	inc	-3 (ix)
00167$:
;../_fsmul.c:273: result >>= 8;
	ld	b, #0x08
00168$:
	srl	-3 (ix)
	rr	-4 (ix)
	rr	-5 (ix)
	rr	-6 (ix)
	djnz	00168$
	jr	00106$
00105$:
;../_fsmul.c:277: result >>= 7;
	ld	b, #0x07
00170$:
	srl	-3 (ix)
	rr	-4 (ix)
	rr	-5 (ix)
	rr	-6 (ix)
	djnz	00170$
;../_fsmul.c:278: exp--;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	dec	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
00106$:
;../_fsmul.c:281: result &= ~HIDDEN;
	ld	a, -6 (ix)
	ld	-6 (ix), a
	ld	a, -5 (ix)
	ld	-5 (ix), a
	ld	a, -4 (ix)
	and	a, #0x7f
	ld	-4 (ix), a
	ld	a, -3 (ix)
	ld	-3 (ix), a
;../_fsmul.c:284: if (exp >= 0x100)
	ld	a, -1 (ix)
	xor	a, #0x80
	sub	a, #0x81
	jr	C,00111$
;../_fsmul.c:285: fl1.l = (sign ? SIGNBIT : 0) | __INFINITY;
	ld	hl, #0
	add	hl, sp
	ld	a, c
	or	a, a
	jr	Z,00115$
	ld	bc, #0x0000
	ld	de, #0x8000
	jr	00116$
00115$:
	ld	bc, #0x0000
	ld	de, #0x0000
00116$:
	set	7, e
	ld	a, d
	or	a, #0x7f
	ld	d, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
	inc	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
	jp	00112$
00111$:
;../_fsmul.c:286: else if (exp < 0)
	bit	7, -1 (ix)
	jr	Z,00108$
;../_fsmul.c:287: fl1.l = 0;
	ld	hl, #0
	add	hl, sp
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), #0x00
	jr	00112$
00108$:
;../_fsmul.c:289: fl1.l = PACK (sign ? SIGNBIT : 0 , exp, result);
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	a, c
	or	a, a
	jr	Z,00117$
	ld	-10 (ix), #0x00
	ld	-9 (ix), #0x00
	ld	-8 (ix), #0x00
	ld	-7 (ix), #0x80
	jr	00118$
00117$:
	xor	a, a
	ld	-10 (ix), a
	ld	-9 (ix), a
	ld	-8 (ix), a
	ld	-7 (ix), a
00118$:
	ld	l, -2 (ix)
	ld	a, -1 (ix)
	ld	h, a
	rla
	sbc	a, a
	ld	bc, #0x0000
	ld	a, #0x07
00172$:
	add	hl, hl
	dec	a
	jr	NZ,00172$
	ld	a, c
	or	a, -10 (ix)
	ld	c, a
	ld	a, b
	or	a, -9 (ix)
	ld	b, a
	ld	a, l
	or	a, -8 (ix)
	ld	l, a
	ld	a, h
	or	a, -7 (ix)
	ld	h, a
	ld	a, c
	or	a, -6 (ix)
	ld	-10 (ix), a
	ld	a, b
	or	a, -5 (ix)
	ld	-9 (ix), a
	ld	a, l
	or	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, h
	or	a, -3 (ix)
	ld	-7 (ix), a
	ld	hl, #0x000a
	add	hl, sp
	ld	bc, #0x0004
	ldir
00112$:
;../_fsmul.c:290: return (fl1.f);
	ld	hl, #0
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
00113$:
;../_fsmul.c:291: }
	ld	sp, ix
	pop	ix
	ret
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
