;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module atanf
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _fabsf
	.globl _atanf
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../atanf.c:55: float atanf(float x) _FLOAT_FUNC_REENTRANT
;	---------------------------------
; Function atanf
; ---------------------------------
_atanf::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;../atanf.c:58: int n=0;
	ld	-2 (ix), #0x00
	ld	-1 (ix), #0x00
;../atanf.c:61: f=fabsf(x);
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_fabsf
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../atanf.c:62: if(f>1.0)
	push	bc
	push	de
	push	de
	push	bc
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	de
	pop	bc
	or	a, a
	jr	Z,00102$
;../atanf.c:64: f=1.0/f;
	push	de
	push	bc
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../atanf.c:65: n=2;
	ld	-2 (ix), #0x02
	ld	-1 (ix), #0x00
00102$:
;../atanf.c:67: if(f>K1)
	push	bc
	push	de
	push	de
	push	bc
	ld	hl, #0x3e89
	push	hl
	ld	hl, #0x30a3
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	de
	pop	bc
	or	a, a
	jp	Z, 00104$
;../atanf.c:69: f=((K2*f-1.0)+f)/(K3+f);
	push	bc
	push	de
	push	de
	push	bc
	ld	hl, #0x3f3b
	push	hl
	ld	hl, #0x67af
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	pop	de
	pop	bc
	push	bc
	push	de
	push	de
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	pop	de
	pop	bc
	ld	hl, #0x3fdd
	push	hl
	ld	hl, #0xb3d7
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../atanf.c:73: n++;
	inc	-2 (ix)
	jr	NZ,00139$
	inc	-1 (ix)
00139$:
00104$:
;../atanf.c:75: if(fabsf(f)<EPS) r=f;
	push	bc
	push	de
	push	de
	push	bc
	call	_fabsf
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	hl, #0x3980
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	de
	pop	bc
	or	a, a
	jp	NZ,00107$
;../atanf.c:78: g=f*f;
	push	bc
	push	de
	push	de
	push	bc
	push	de
	push	bc
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	hl, #0xbd50
	push	hl
	ld	hl, #0x8691
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	ld	hl, #0xbef1
	push	hl
	ld	hl, #0x10f6
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	pop	de
	pop	bc
	push	bc
	push	de
	push	de
	push	bc
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	ld	hl, #0x3fb4
	push	hl
	ld	hl, #0xccd3
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	pop	de
	pop	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
00107$:
;../atanf.c:81: if(n>1) r=-r;
	ld	a, #0x01
	cp	a, -2 (ix)
	ld	a, #0x00
	sbc	a, -1 (ix)
	jp	PO, 00140$
	xor	a, #0x80
00140$:
	jp	P, 00109$
	ld	a, d
	xor	a,#0x80
	ld	d, a
00109$:
;../atanf.c:82: r+=a[n];
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	add	hl, hl
	add	hl, hl
	ld	a, #<(_atanf_a_65536_26)
	add	a, l
	ld	l, a
	ld	a, #>(_atanf_a_65536_26)
	adc	a, h
	ld	h, a
	push	de
	push	bc
	ex	de,hl
	ld	hl, #0x000a
	add	hl, sp
	ex	de, hl
	ld	bc, #0x0004
	ldir
	pop	bc
	pop	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
;../atanf.c:83: if(x<0.0) r=-r;
	ex	(sp),hl
	push	de
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	de
	pop	bc
	or	a, a
	jr	Z,00111$
	ld	a, d
	xor	a,#0x80
	ld	d, a
00111$:
;../atanf.c:84: return r;
	ld	l, c
	ld	h, b
;../atanf.c:85: }
	ld	sp, ix
	pop	ix
	ret
_atanf_a_65536_26:
	.byte #0x00, #0x00, #0x00, #0x00	;  0.000000e+00
	.byte #0x92, #0x0a, #0x06, #0x3f	;  5.235988e-01
	.byte #0xdb, #0x0f, #0xc9, #0x3f	;  1.570796e+00
	.byte #0x92, #0x0a, #0x86, #0x3f	;  1.047198e+00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
