;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module bsearch
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _bsearch
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../bsearch.c:31: void *bsearch(const void *key, const void *base, size_t nmemb, size_t size, int (*compar)(const void *, const void *) __reentrant)
;	---------------------------------
; Function bsearch
; ---------------------------------
_bsearch::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;../bsearch.c:33: for(const char *left = base; nmemb;)
	ld	c, 6 (ix)
	ld	b, 7 (ix)
00109$:
	ld	a, 9 (ix)
	or	a, 8 (ix)
	jp	Z, 00107$
;../bsearch.c:35: const char *middle = left + nmemb / 2 * size;
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	srl	d
	rr	e
	push	bc
	push	de
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	push	hl
	push	de
	call	__mulint
	pop	af
	pop	af
	pop	de
	pop	bc
	add	hl, bc
	inc	sp
	inc	sp
	push	hl
;../bsearch.c:36: int c = (*compar)(key, middle);
	ld	a, -4 (ix)
	ld	-2 (ix), a
	ld	a, -3 (ix)
	ld	-1 (ix), a
	push	bc
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	ld	l, 12 (ix)
	ld	h, 13 (ix)
	call	___sdcc_call_hl
	pop	af
	pop	af
	pop	de
	pop	bc
;../bsearch.c:38: if(c < 0)
	bit	7, h
	jr	Z,00105$
;../bsearch.c:39: nmemb = nmemb / 2;	
	ld	8 (ix), e
	ld	9 (ix), d
	jr	00109$
00105$:
;../bsearch.c:40: else if(c > 0)
	xor	a, a
	cp	a, l
	sbc	a, h
	jp	PO, 00133$
	xor	a, #0x80
00133$:
	jp	P, 00102$
;../bsearch.c:42: left = middle + size;
	ld	a, -4 (ix)
	add	a, 10 (ix)
	ld	c, a
	ld	a, -3 (ix)
	adc	a, 11 (ix)
	ld	b, a
;../bsearch.c:43: nmemb = (nmemb - 1) / 2;
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	dec	de
	ld	8 (ix), e
	ld	9 (ix), d
	srl	9 (ix)
	rr	8 (ix)
	jp	00109$
00102$:
;../bsearch.c:46: return(middle);
	pop	bc
	pop	hl
	push	hl
	push	bc
	jr	00111$
00107$:
;../bsearch.c:49: return(0);
	ld	hl, #0x0000
00111$:
;../bsearch.c:50: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
