;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module expf
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _ldexpf
	.globl _expf
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../expf.c:331: float expf(float x) _FLOAT_FUNC_REENTRANT
;	---------------------------------
; Function expf
; ---------------------------------
_expf::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-15
	add	hl, sp
	ld	sp, hl
;../expf.c:337: if(x>=0.0)
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-1 (ix), l
	bit	0, -1 (ix)
	jr	NZ,00102$
;../expf.c:338: { y=x;  sign=0; }
	ld	hl, #5
	add	hl, sp
	ex	de, hl
	ld	hl, #19
	add	hl, sp
	ld	bc, #4
	ldir
	ld	-11 (ix), #0x00
	jr	00103$
00102$:
;../expf.c:340: { y=-x; sign=1; }
	ld	a, 7 (ix)
	xor	a,#0x80
	ld	-1 (ix), a
	ld	a, 4 (ix)
	ld	-4 (ix), a
	ld	a, 5 (ix)
	ld	-3 (ix), a
	ld	a, 6 (ix)
	ld	-2 (ix), a
	ld	hl, #5
	add	hl, sp
	ex	de, hl
	ld	hl, #11
	add	hl, sp
	ld	bc, #4
	ldir
	ld	-11 (ix), #0x01
00103$:
;../expf.c:342: if(y<EXPEPS) return 1.0;
	ld	hl, #0x33d6
	push	hl
	ld	hl, #0xbf95
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-1 (ix), l
	ld	a, l
	or	a, a
	jr	Z,00105$
	ld	hl, #0x0000
	ld	de, #0x3f80
	jp	00118$
00105$:
;../expf.c:344: if(y>BIGX)
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x42b1
	push	hl
	ld	hl, #0x7218
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00110$
;../expf.c:346: if(sign)
	bit	0, -11 (ix)
	jr	Z,00107$
;../expf.c:348: errno=ERANGE;
	ld	hl, #0x0022
	ld	(_errno), hl
;../expf.c:350: ;
	ld	hl, #0xffff
	ld	de, #0x7f7f
	jp	00118$
00107$:
;../expf.c:354: return 0.0;
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00118$
00110$:
;../expf.c:358: z=y*K1;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x3fb8
	push	hl
	ld	hl, #0xaa3b
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-15 (ix), l
	ld	-14 (ix), h
	ld	-13 (ix), e
	ld	-12 (ix), d
	ld	hl, #9
	add	hl, sp
	ex	de, hl
	ld	hl, #0
	add	hl, sp
	ld	bc, #4
	ldir
;../expf.c:359: n=z;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fs2sint
	pop	af
	pop	af
	ld	-2 (ix), l
	ld	-1 (ix), h
;../expf.c:361: if(n<0) --n;
	bit	7, -1 (ix)
	jr	Z,00112$
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	dec	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
00112$:
;../expf.c:362: if(z-n>=0.5) ++n;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	___sint2fs
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	push	de
	push	bc
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-3 (ix), l
	bit	0, -3 (ix)
	jr	NZ,00114$
	inc	-2 (ix)
	jr	NZ,00155$
	inc	-1 (ix)
00155$:
00114$:
;../expf.c:363: xn=n;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	call	___sint2fs
	pop	af
	ld	c, l
	ld	b, h
;../expf.c:364: g=((y-xn*C1))-xn*C2;
	push	bc
	push	de
	push	de
	push	bc
	ld	hl, #0x3f31
	push	hl
	ld	hl, #0x8000
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	pop	de
	pop	bc
	push	de
	push	bc
	ld	hl, #0xb95e
	push	hl
	ld	hl, #0x8083
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	push	de
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	hl, #0
	add	hl, sp
	ex	de, hl
	ld	hl, #9
	add	hl, sp
	ld	bc, #4
	ldir
;../expf.c:365: z=g*g;
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	l, -15 (ix)
	ld	h, -14 (ix)
	push	hl
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	l, -15 (ix)
	ld	h, -14 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
;../expf.c:366: r=P(z)*g;
	ld	-8 (ix), e
	ld	-7 (ix), d
	push	de
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x3b88
	push	hl
	ld	hl, #0x5308
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	hl, #0x3e80
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	l, -15 (ix)
	ld	h, -14 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
;../expf.c:367: r=0.5+(r/(Q(z)-r));
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x3d4c
	push	hl
	ld	hl, #0xbf5b
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-10 (ix), l
	ld	-9 (ix), h
	ld	-8 (ix), e
	ld	-7 (ix), d
	push	de
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), e
	ld	-3 (ix), d
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-15 (ix), l
	ld	-14 (ix), h
	ld	-13 (ix), e
	ld	-12 (ix), d
	ld	hl, #7
	add	hl, sp
	ex	de, hl
	ld	hl, #0
	add	hl, sp
	ld	bc, #4
	ldir
;../expf.c:369: n++;
	ld	a, -2 (ix)
	add	a, #0x01
	ld	-4 (ix), a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
;../expf.c:370: z=ldexpf(r, n);
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	_ldexpf
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;../expf.c:371: if(sign)
	bit	0, -11 (ix)
	jr	Z,00116$
;../expf.c:372: return 1.0/z;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	jr	00118$
00116$:
;../expf.c:374: return z;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
00118$:
;../expf.c:375: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
