;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module realloc
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _memmove
	.globl _free
	.globl _malloc
	.globl _realloc
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../realloc.c:56: void *realloc(void *ptr, size_t size)
;	---------------------------------
; Function realloc
; ---------------------------------
_realloc::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-18
	add	hl, sp
	ld	sp, hl
;../realloc.c:69: if(!ptr)
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	NZ,00102$
;../realloc.c:70: return(malloc(size));
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	call	_malloc
	pop	af
	jp	00132$
00102$:
;../realloc.c:72: if(!size)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	NZ,00104$
;../realloc.c:74: free(ptr);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_free
	pop	af
;../realloc.c:75: return(0);
	ld	hl, #0x0000
	jp	00132$
00104$:
;../realloc.c:78: prev_free = 0, pf = 0;
	ld	hl, #0x0000
	ex	(sp), hl
	ld	-16 (ix), #0x00
	ld	-15 (ix), #0x00
;../realloc.c:79: for(h = __sdcc_heap_free, f = &__sdcc_heap_free; h && h < ptr; prev_free = h, pf = f, f = &(h->next_free), h = h->next_free); // Find adjacent blocks in free list
	ld	bc, (___sdcc_heap_free)
	ld	-14 (ix), #<(___sdcc_heap_free)
	ld	-13 (ix), #>(___sdcc_heap_free)
00130$:
	ld	a, b
	or	a, c
	jr	Z,00105$
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	a, c
	sub	a, e
	ld	a, b
	sbc	a, d
	jr	NC,00105$
	inc	sp
	inc	sp
	push	bc
	ld	a, -14 (ix)
	ld	-16 (ix), a
	ld	a, -13 (ix)
	ld	-15 (ix), a
	inc	bc
	inc	bc
	ld	h, b
	ld	-14 (ix), c
	ld	-13 (ix), h
	ld	l, c
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	jr	00130$
00105$:
;../realloc.c:80: next_free = h;
	ld	-12 (ix), c
	ld	-11 (ix), b
;../realloc.c:82: if(!size || size + offsetof(struct header, next_free) < size)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	Z,00106$
	ld	c, 6 (ix)
	ld	b, 7 (ix)
	inc	bc
	inc	bc
	ld	a, c
	sub	a, 6 (ix)
	ld	a, b
	sbc	a, 7 (ix)
	jr	NC,00107$
00106$:
;../realloc.c:83: return(0);
	ld	hl, #0x0000
	jp	00132$
00107$:
;../realloc.c:84: blocksize = size + offsetof(struct header, next_free);
	ld	-10 (ix), c
	ld	-9 (ix), b
;../realloc.c:85: if(blocksize < sizeof(struct header)) // Requiring a minimum size makes it easier to implement free(), and avoid memory leaks.
	ld	a, -10 (ix)
	sub	a, #0x04
	ld	a, -9 (ix)
	sbc	a, #0x00
	jr	NC,00110$
;../realloc.c:86: blocksize = sizeof(struct header);
	ld	-10 (ix), #0x04
	ld	-9 (ix), #0x00
00110$:
;../realloc.c:88: h = (void HEAPSPACE *)((char HEAPSPACE *)(ptr) - offsetof(struct header, next_free));
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	dec	bc
	dec	bc
;../realloc.c:89: oldblocksize = (char HEAPSPACE *)(h->next) - (char HEAPSPACE *)h;
	ld	-8 (ix), c
	ld	-7 (ix), b
	ld	l, c
	ld	h, b
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	e, c
	ld	d, b
	ld	a, -8 (ix)
	ld	-6 (ix), a
	ld	a, -7 (ix)
	ld	-5 (ix), a
	ld	a, e
	sub	a, -6 (ix)
	ld	e, a
	ld	a, d
	sbc	a, -5 (ix)
	ld	d, a
	ld	-4 (ix), e
	ld	-3 (ix), d
;../realloc.c:91: maxblocksize = oldblocksize;
	ld	a, -4 (ix)
	ld	-2 (ix), a
	ld	a, -3 (ix)
	ld	-1 (ix), a
;../realloc.c:92: if(prev_free && prev_free->next == h) // Can merge with previous block
	ld	a, -17 (ix)
	or	a, -18 (ix)
	jr	Z,00112$
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, -8 (ix)
	sub	a, e
	jr	NZ,00112$
	ld	a, -7 (ix)
	sub	a, d
	jr	NZ,00112$
;../realloc.c:93: maxblocksize += (char HEAPSPACE *)h - (char HEAPSPACE *)prev_free;
	pop	de
	push	de
	ld	a, -6 (ix)
	sub	a, e
	ld	e, a
	ld	a, -5 (ix)
	sbc	a, d
	ld	d, a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	add	hl, de
	ld	-2 (ix), l
	ld	-1 (ix), h
00112$:
;../realloc.c:94: if(next_free == h->next) // Can merge with next block
	ld	a, -12 (ix)
	sub	a, c
	jr	NZ,00115$
	ld	a, -11 (ix)
	sub	a, b
	jr	NZ,00115$
;../realloc.c:95: maxblocksize += (char HEAPSPACE *)(next_free->next) - (char HEAPSPACE *)next_free;
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	c, -12 (ix)
	ld	b, -11 (ix)
	cp	a, a
	sbc	hl, bc
	ld	a, -2 (ix)
	add	a, l
	ld	-2 (ix), a
	ld	a, -1 (ix)
	adc	a, h
	ld	-1 (ix), a
00115$:
;../realloc.c:97: if(blocksize <= maxblocksize) // Can resize in place.
	ld	a, -2 (ix)
	sub	a, -10 (ix)
	ld	a, -1 (ix)
	sbc	a, -9 (ix)
	jp	C, 00125$
;../realloc.c:99: if(prev_free && prev_free->next == h) // Always move into previous block to defragment
	ld	a, -17 (ix)
	or	a, -18 (ix)
	jr	Z,00117$
	pop	hl
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, -8 (ix)
	sub	a, c
	jr	NZ,00117$
	ld	a, -7 (ix)
	sub	a, b
	jr	NZ,00117$
;../realloc.c:101: memmove(prev_free, h, blocksize <= oldblocksize ? blocksize : oldblocksize);
	ld	a, -4 (ix)
	sub	a, -10 (ix)
	ld	a, -3 (ix)
	sbc	a, -9 (ix)
	jr	C,00134$
	ld	a, -10 (ix)
	ld	-4 (ix), a
	ld	a, -9 (ix)
	ld	-3 (ix), a
00134$:
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	pop	bc
	push	bc
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	_memmove
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;../realloc.c:102: h = prev_free;
	ld	a, -18 (ix)
	ld	-8 (ix), a
	ld	a, -17 (ix)
	ld	-7 (ix), a
;../realloc.c:103: *pf = next_free;
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	a, -12 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -11 (ix)
	ld	(hl), a
;../realloc.c:104: f = pf;
	ld	a, -16 (ix)
	ld	-14 (ix), a
	ld	a, -15 (ix)
	ld	-13 (ix), a
00117$:
;../realloc.c:107: if(next_free && next_free == h->next) // Merge with following block
	ld	a, -11 (ix)
	or	a, -12 (ix)
	jr	Z,00120$
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
	ld	a, -12 (ix)
	sub	a, -4 (ix)
	jr	NZ,00120$
	ld	a, -11 (ix)
	sub	a, -3 (ix)
	jr	NZ,00120$
;../realloc.c:109: h->next = next_free->next;
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
;../realloc.c:110: *f = next_free->next_free;
	ld	a, -12 (ix)
	ld	-4 (ix), a
	ld	a, -11 (ix)
	ld	-3 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
	inc	hl
	ld	a, -3 (ix)
	ld	(hl), a
00120$:
;../realloc.c:113: if(maxblocksize >= blocksize + sizeof(struct header)) // Create new block from free space
	ld	a, -10 (ix)
	add	a, #0x04
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, -2 (ix)
	sub	a, c
	ld	a, -1 (ix)
	sbc	a, b
	jr	C,00123$
;../realloc.c:115: header_t *const newheader = (header_t *const)((char HEAPSPACE *)h + blocksize);
	ld	c, -8 (ix)
	ld	b, -7 (ix)
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	add	hl, bc
	ld	c, l
	ld	b, h
;../realloc.c:116: newheader->next = h->next;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	ld	(hl), e
	inc	hl
	ld	(hl), d
;../realloc.c:117: newheader->next_free = *f;
	push	bc
	pop	iy
	inc	iy
	inc	iy
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	0 (iy), e
	ld	1 (iy), d
;../realloc.c:118: *f = newheader;
	ld	l, -14 (ix)
	ld	h, -13 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
;../realloc.c:119: h->next = newheader;
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
00123$:
;../realloc.c:122: return(&(h->next_free));
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	inc	hl
	inc	hl
	jr	00132$
00125$:
;../realloc.c:125: if(ret = malloc(size))
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	call	_malloc
	pop	af
	ld	c, l
	ld	b, h
	ld	l, c
	ld	a,b
	ld	h,a
	or	a, c
	jr	Z,00127$
;../realloc.c:127: size_t oldsize = oldblocksize - offsetof(struct header, next_free);
	ld	e, -4 (ix)
	ld	d, -3 (ix)
	dec	de
	dec	de
;../realloc.c:128: memcpy(ret, ptr, size <= oldsize ? size : oldsize);
	ld	a, e
	sub	a, 6 (ix)
	ld	a, d
	sbc	a, 7 (ix)
	jr	C,00136$
	ld	e, 6 (ix)
	ld	d, 7 (ix)
00136$:
	push	hl
	push	de
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	push	hl
	call	___memcpy
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	call	_free
	pop	af
	pop	hl
;../realloc.c:130: return(ret);
	jr	00132$
00127$:
;../realloc.c:133: return(0);
	ld	hl, #0x0000
00132$:
;../realloc.c:134: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
