;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module sincoshf
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _sincoshf
	.globl _expf
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../sincoshf.c:56: float sincoshf(float x, bool iscosh)
;	---------------------------------
; Function sincoshf
; ---------------------------------
_sincoshf::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-15
	add	hl, sp
	ld	sp, hl
;../sincoshf.c:62: else { y=x;  sign=0; }
	ld	hl, #11
	add	hl, sp
	ex	de, hl
	ld	hl, #19
	add	hl, sp
	ld	bc, #4
	ldir
;../sincoshf.c:61: if (x<0.0) { y=-x; sign=1; }
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-5 (ix), l
	ld	a, l
	or	a, a
	jr	Z,00102$
	ld	a, 7 (ix)
	xor	a,#0x80
	ld	-12 (ix), a
	ld	a, 4 (ix)
	ld	-15 (ix), a
	ld	a, 5 (ix)
	ld	-14 (ix), a
	ld	a, 6 (ix)
	ld	-13 (ix), a
	ld	hl, #5
	add	hl, sp
	ex	de, hl
	ld	hl, #0
	add	hl, sp
	ld	bc, #4
	ldir
	ld	-5 (ix), #0x01
	jr	00103$
00102$:
;../sincoshf.c:62: else { y=x;  sign=0; }
	ld	hl, #5
	add	hl, sp
	ex	de, hl
	ld	hl, #11
	add	hl, sp
	ld	bc, #4
	ldir
	ld	-5 (ix), #0x00
00103$:
;../sincoshf.c:64: if ((y>1.0) || iscosh)
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	a, l
	or	a, a
	jr	NZ,00117$
	bit	0, 8 (ix)
	jp	Z, 00118$
00117$:
;../sincoshf.c:66: if(y>YBAR)
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	hl, #0x4110
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-1 (ix), l
	ld	a, l
	or	a, a
	jp	Z, 00110$
;../sincoshf.c:68: w=y-K1;
	ld	hl, #0x3f31
	push	hl
	ld	hl, #0x7300
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fssub
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
;../sincoshf.c:69: if (w>WMAX)
	push	hl
	push	de
	push	hl
	push	de
	ld	hl, #0x4233
	push	hl
	ld	hl, #0xbdcf
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	Z,00105$
;../sincoshf.c:71: errno=ERANGE;
	ld	hl, #0x0022
	ld	(_errno), hl
;../sincoshf.c:72: z=HUGE_VALF;
	ld	-4 (ix), #0xff
	ld	-3 (ix), #0xff
	ld	-2 (ix), #0x7f
	ld	-1 (ix), #0x7f
	jp	00111$
00105$:
;../sincoshf.c:76: z=expf(w);
	push	hl
	push	de
	call	_expf
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../sincoshf.c:77: z+=K3*z;
	push	bc
	push	de
	push	de
	push	bc
	ld	hl, #0x3768
	push	hl
	ld	hl, #0x0897
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	de
	pop	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	jr	00111$
00110$:
;../sincoshf.c:82: z=expf(y);
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	_expf
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../sincoshf.c:83: w=1.0/z;
	push	bc
	push	de
	push	de
	push	bc
	ld	hl, #0x3f80
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	de
	pop	bc
;../sincoshf.c:84: if(!iscosh) w=-w;
	bit	0, 8 (ix)
	jr	NZ,00108$
	ld	a, -1 (ix)
	xor	a,#0x80
	ld	-1 (ix), a
00108$:
;../sincoshf.c:85: z=(z+w)*0.5;
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	hl, #0x3f00
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
00111$:
;../sincoshf.c:87: if(sign) z=-z;
	bit	0, -5 (ix)
	jp	Z, 00119$
	ld	a, -1 (ix)
	xor	a,#0x80
	ld	-1 (ix), a
	jp	00119$
00118$:
;../sincoshf.c:91: if (y<EPS)
	ld	hl, #0x3980
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	___fslt
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	or	a, a
;../sincoshf.c:92: z=x;
	jp	NZ,00119$
;../sincoshf.c:95: z=x*x;
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-8 (ix), l
	ld	-7 (ix), h
;../sincoshf.c:96: z=x+x*z*P(z)/Q(z);
	ld	-6 (ix), e
	ld	-5 (ix), d
	push	de
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	hl, #0xbe42
	push	hl
	ld	hl, #0xe6ea
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	hl, #0xc0e4
	push	hl
	ld	hl, #0x69f0
	push	hl
	push	de
	push	bc
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	ld	hl, #0xc22b
	push	hl
	ld	hl, #0x4f93
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fsdiv
	pop	af
	pop	af
	pop	af
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	push	hl
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
00119$:
;../sincoshf.c:99: return z;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
;../sincoshf.c:100: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
