;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module time
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _RtcRead
	.globl _sprintf
	.globl ___day
	.globl ___month
	.globl _time
	.globl _asctime
	.globl _ctime
	.globl _localtime
	.globl _gmtime
	.globl _mktime
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_ascTimeBuffer:
	.ds 32
_lastTime:
	.ds 12
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../time.c:42: unsigned char RtcRead(struct tm *timeptr) {
;	---------------------------------
; Function RtcRead
; ---------------------------------
_RtcRead::
;../time.c:45: return 0;
	ld	l, #0x00
;../time.c:46: }
	ret
;../time.c:50: time_t time(time_t *timeptr) {
;	---------------------------------
; Function time
; ---------------------------------
_time::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-12
	add	hl, sp
	ld	sp, hl
;../time.c:52: time_t t=(time_t) -1;
	ld	bc, #0xffff
	ld	de, #0xffff
;../time.c:54: if (RtcRead(&now)) {
	ld	hl, #0
	add	hl, sp
	push	hl
	pop	iy
	push	hl
	push	bc
	push	de
	push	iy
	call	_RtcRead
	pop	af
	ld	a, l
	pop	de
	pop	bc
	pop	hl
	or	a, a
	jr	Z,00102$
;../time.c:55: t=mktime(&now);
	push	hl
	call	_mktime
	pop	af
	ld	c, l
	ld	b, h
00102$:
;../time.c:57: if (timeptr) {
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	Z,00104$
;../time.c:58: *timeptr=t;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
	inc	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
00104$:
;../time.c:60: return t;
	ld	l, c
	ld	h, b
;../time.c:61: }
	ld	sp, ix
	pop	ix
	ret
;../time.c:73: static void CheckTime(struct tm *timeptr) {
;	---------------------------------
; Function CheckTime
; ---------------------------------
_CheckTime:
;../time.c:84: if (timeptr->tm_sec>59) timeptr->tm_sec=59;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	a, (bc)
	ld	e, a
	ld	a,#0x3b
	cp	a,e
	jr	NC,00102$
	ld	(bc), a
00102$:
;../time.c:85: if (timeptr->tm_min>59) timeptr->tm_min=59;
	ld	l, c
	ld	h, b
	inc	hl
	ld	e, (hl)
	ld	a, #0x3b
	sub	a, e
	jr	NC,00104$
	ld	(hl), #0x3b
00104$:
;../time.c:86: if (timeptr->tm_hour>23) timeptr->tm_hour=23;
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	e, (hl)
	ld	a, #0x17
	sub	a, e
	jr	NC,00106$
	ld	(hl), #0x17
00106$:
;../time.c:87: if (timeptr->tm_wday>6) timeptr->tm_wday=6;
	ld	hl, #0x0007
	add	hl, bc
	ld	e, (hl)
	ld	a, #0x06
	sub	a, e
	jr	NC,00108$
	ld	(hl), #0x06
00108$:
;../time.c:88: if (timeptr->tm_mday<1) timeptr->tm_mday=1;
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	e, (hl)
	ld	a, e
	sub	a, #0x01
	jr	NC,00112$
	ld	(hl), #0x01
	jr	00113$
00112$:
;../time.c:89: else if (timeptr->tm_mday>31) timeptr->tm_mday=31;
	ld	a, #0x1f
	sub	a, e
	jr	NC,00113$
	ld	(hl), #0x1f
00113$:
;../time.c:90: if (timeptr->tm_mon>11) timeptr->tm_mon=11;
	ld	hl, #0x0004
	add	hl, bc
	ld	e, (hl)
	ld	a, #0x0b
	sub	a, e
	jr	NC,00115$
	ld	(hl), #0x0b
00115$:
;../time.c:91: if (timeptr->tm_year<0) timeptr->tm_year=0;
	ld	hl, #0x0005
	add	hl, bc
	push	hl
	inc	hl
	ld	b, (hl)
	pop	hl
	bit	7, b
	ret	Z
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;../time.c:92: }
	ret
_monthDays:
	.db #0x1f	; 31
	.db #0x1c	; 28
	.db #0x1f	; 31
	.db #0x1e	; 30
	.db #0x1f	; 31
	.db #0x1e	; 30
	.db #0x1f	; 31
	.db #0x1f	; 31
	.db #0x1e	; 30
	.db #0x1f	; 31
	.db #0x1e	; 30
	.db #0x1f	; 31
___month:
	.dw __str_0
	.dw __str_1
	.dw __str_2
	.dw __str_3
	.dw __str_4
	.dw __str_5
	.dw __str_6
	.dw __str_7
	.dw __str_8
	.dw __str_9
	.dw __str_10
	.dw __str_11
___day:
	.dw __str_12
	.dw __str_13
	.dw __str_14
	.dw __str_15
	.dw __str_16
	.dw __str_17
	.dw __str_18
__str_0:
	.ascii "Jan"
	.db 0x00
__str_1:
	.ascii "Feb"
	.db 0x00
__str_2:
	.ascii "Mar"
	.db 0x00
__str_3:
	.ascii "Apr"
	.db 0x00
__str_4:
	.ascii "May"
	.db 0x00
__str_5:
	.ascii "Jun"
	.db 0x00
__str_6:
	.ascii "Jul"
	.db 0x00
__str_7:
	.ascii "Aug"
	.db 0x00
__str_8:
	.ascii "Sep"
	.db 0x00
__str_9:
	.ascii "Oct"
	.db 0x00
__str_10:
	.ascii "Nov"
	.db 0x00
__str_11:
	.ascii "Dec"
	.db 0x00
__str_12:
	.ascii "Sun"
	.db 0x00
__str_13:
	.ascii "Mon"
	.db 0x00
__str_14:
	.ascii "Tue"
	.db 0x00
__str_15:
	.ascii "Wed"
	.db 0x00
__str_16:
	.ascii "Thu"
	.db 0x00
__str_17:
	.ascii "Fri"
	.db 0x00
__str_18:
	.ascii "Sat"
	.db 0x00
;../time.c:95: char *asctime(struct tm *timeptr) {
;	---------------------------------
; Function asctime
; ---------------------------------
_asctime::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;../time.c:96: CheckTime(timeptr);
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_CheckTime
	pop	af
;../time.c:100: timeptr->tm_year+1900);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	l, c
	ld	h, b
	ld	de, #0x0005
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #0x076c
	add	hl, de
	ex	(sp), hl
;../time.c:99: timeptr->tm_hour, timeptr->tm_min, timeptr->tm_sec, 
	ld	a, (bc)
	ld	-8 (ix), a
	ld	-7 (ix), #0x00
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	ld	-6 (ix), a
	ld	-5 (ix), #0x00
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-4 (ix), a
	ld	-3 (ix), #0x00
;../time.c:98: __day[timeptr->tm_wday], __month[timeptr->tm_mon], timeptr->tm_mday,
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-2 (ix), a
	ld	-1 (ix), #0x00
	ld	de, #___month+0
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	l, (hl)
	ld	h, #0x00
	add	hl, hl
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	ld	bc, #0x0007
	add	hl, bc
	ld	l, (hl)
	ld	h, #0x00
	add	hl, hl
	ld	bc, #___day
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;../time.c:97: sprintf (ascTimeBuffer, "%s %s %2d %02d:%02d:%02d %04d\n",
	pop	hl
	push	hl
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	push	de
	push	bc
	ld	hl, #___str_19
	push	hl
	ld	hl, #_ascTimeBuffer
	push	hl
	call	_sprintf
	ld	hl, #18
	add	hl, sp
	ld	sp, hl
;../time.c:101: return ascTimeBuffer;
	ld	hl, #_ascTimeBuffer
;../time.c:102: }
	ld	sp, ix
	pop	ix
	ret
___str_19:
	.ascii "%s %s %2d %02d:%02d:%02d %04d"
	.db 0x0a
	.db 0x00
;../time.c:104: char *ctime(time_t *timep) {
;	---------------------------------
; Function ctime
; ---------------------------------
_ctime::
;../time.c:105: return asctime(localtime(timep));
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_localtime
	ex	(sp),hl
	call	_asctime
	pop	af
;../time.c:106: }
	ret
;../time.c:121: struct tm *localtime(time_t *timep) {
;	---------------------------------
; Function localtime
; ---------------------------------
_localtime::
;../time.c:122: return gmtime(timep);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_gmtime
	pop	af
;../time.c:123: }
	ret
;../time.c:125: struct tm *gmtime(time_t *timep) {
;	---------------------------------
; Function gmtime
; ---------------------------------
_gmtime::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-16
	add	hl, sp
	ld	sp, hl
;../time.c:126: unsigned long epoch=*timep;
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
;../time.c:131: lastTime.tm_sec=epoch%60;
	push	bc
	push	de
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x003c
	push	hl
	push	de
	push	bc
	call	__modulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	de
	pop	bc
	ld	a, -4 (ix)
	ld	(#_lastTime),a
;../time.c:132: epoch/=60; // now it is minutes
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x003c
	push	hl
	push	de
	push	bc
	call	__divulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../time.c:133: lastTime.tm_min=epoch%60;
	push	bc
	push	de
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x003c
	push	hl
	push	de
	push	bc
	call	__modulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	de
	pop	bc
	ld	a, -4 (ix)
	ld	(#(_lastTime + 0x0001)),a
;../time.c:134: epoch/=60; // now it is hours
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x003c
	push	hl
	push	de
	push	bc
	call	__divulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;../time.c:135: lastTime.tm_hour=epoch%24;
	push	bc
	push	de
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0018
	push	hl
	push	de
	push	bc
	call	__modulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	de
	pop	bc
	ld	a, -4 (ix)
	ld	(#(_lastTime + 0x0002)),a
;../time.c:136: epoch/=24; // now it is days
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0018
	push	hl
	push	de
	push	bc
	call	__divulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-16 (ix), l
	ld	-15 (ix), h
	ld	-14 (ix), e
	ld	-13 (ix), d
;../time.c:137: lastTime.tm_wday=(epoch+4)%7;
	ld	a, -16 (ix)
	add	a, #0x04
	ld	c, a
	ld	a, -15 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, -14 (ix)
	adc	a, #0x00
	ld	e, a
	ld	a, -13 (ix)
	adc	a, #0x00
	ld	d, a
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0007
	push	hl
	push	de
	push	bc
	call	__modulong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	ld	(#(_lastTime + 0x0007)),a
;../time.c:140: days=0;
	ld	bc, #0x0000
	ld	de, #0x0000
;../time.c:141: while((days += (LEAP_YEAR(year) ? 366 : 365)) <= epoch) {
	ld	-2 (ix), #0xb2
	ld	-1 (ix), #0x07
00101$:
	ld	a, -2 (ix)
	and	a, #0x03
	ld	-12 (ix), a
	ld	-11 (ix), #0x00
	ld	a, #0x00
	or	a, -12 (ix)
	jr	NZ,00118$
	ld	hl, #0x016e
	jr	00119$
00118$:
	ld	hl, #0x016d
00119$:
	ld	-10 (ix), l
	ld	a, h
	ld	-9 (ix), a
	rla
	sbc	a, a
	ld	-8 (ix), a
	ld	-7 (ix), a
	ld	a, c
	add	a, -10 (ix)
	ld	-6 (ix), a
	ld	a, b
	adc	a, -9 (ix)
	ld	-5 (ix), a
	ld	a, e
	adc	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, d
	adc	a, -7 (ix)
	ld	-3 (ix), a
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	e, -4 (ix)
	ld	d, -3 (ix)
	ld	a, -16 (ix)
	sub	a, -6 (ix)
	ld	a, -15 (ix)
	sbc	a, -5 (ix)
	ld	a, -14 (ix)
	sbc	a, -4 (ix)
	ld	a, -13 (ix)
	sbc	a, -3 (ix)
	jr	C,00103$
;../time.c:142: year++;
	inc	-2 (ix)
	jr	NZ,00101$
	inc	-1 (ix)
	jr	00101$
00103$:
;../time.c:144: lastTime.tm_year=year-1900;
	ld	iy, #_lastTime + 5
	ld	a, -2 (ix)
	add	a, #0x94
	ld	l, a
	ld	a, -1 (ix)
	adc	a, #0xf8
	ld	h, a
	ld	0 (iy), l
	ld	1 (iy), h
;../time.c:146: days -= LEAP_YEAR(year) ? 366 : 365;
	ld	a, -12 (ix)
	ld	-6 (ix), a
	ld	a, -11 (ix)
	ld	-5 (ix), a
	ld	a, -11 (ix)
	or	a, -12 (ix)
	jr	NZ,00120$
	ld	hl, #0x016e
	jr	00121$
00120$:
	ld	hl, #0x016d
00121$:
	ld	-4 (ix), l
	ld	a, h
	ld	-3 (ix), a
	rla
	sbc	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
	ld	a, c
	sub	a, -4 (ix)
	ld	c, a
	ld	a, b
	sbc	a, -3 (ix)
	ld	b, a
	ld	a, e
	sbc	a, -2 (ix)
	ld	e, a
	ld	a, d
	sbc	a, -1 (ix)
	ld	d, a
;../time.c:147: epoch -= days; // now it is days in this year, starting at 0
	ld	a, -16 (ix)
	sub	a, c
	ld	-4 (ix), a
	ld	a, -15 (ix)
	sbc	a, b
	ld	-3 (ix), a
	ld	a, -14 (ix)
	sbc	a, e
	ld	-2 (ix), a
	ld	a, -13 (ix)
	sbc	a, d
	ld	-1 (ix), a
;../time.c:148: lastTime.tm_yday=epoch;
	ld	c, -4 (ix)
	ld	b, -3 (ix)
	ld	((_lastTime + 0x0008)), bc
;../time.c:153: for (month=0; month<12; month++) {
	ld	-7 (ix), #0x00
00114$:
;../time.c:154: if (month==1) { // februari
	ld	a, -7 (ix)
	dec	a
	jr	NZ,00108$
;../time.c:155: if (LEAP_YEAR(year)) {
	ld	a, -5 (ix)
	or	a, -6 (ix)
	jr	NZ,00105$
;../time.c:156: monthLength=29;
	ld	c, #0x1d
	jr	00109$
00105$:
;../time.c:158: monthLength=28;
	ld	c, #0x1c
	jr	00109$
00108$:
;../time.c:161: monthLength = monthDays[month];
	ld	a, #<(_monthDays)
	add	a, -7 (ix)
	ld	-9 (ix), a
	ld	a, #>(_monthDays)
	adc	a, #0x00
	ld	-8 (ix), a
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	ld	c, (hl)
00109$:
;../time.c:164: if (epoch>=monthLength) {
	ld	b, #0x00
	ld	de, #0x0000
	ld	a, -4 (ix)
	sub	a, c
	ld	a, -3 (ix)
	sbc	a, b
	ld	a, -2 (ix)
	sbc	a, e
	ld	a, -1 (ix)
	sbc	a, d
	jr	C,00113$
;../time.c:165: epoch-=monthLength;
	ld	a, -4 (ix)
	sub	a, c
	ld	-4 (ix), a
	ld	a, -3 (ix)
	sbc	a, b
	ld	-3 (ix), a
	ld	a, -2 (ix)
	sbc	a, e
	ld	-2 (ix), a
	ld	a, -1 (ix)
	sbc	a, d
	ld	-1 (ix), a
;../time.c:153: for (month=0; month<12; month++) {
	inc	-7 (ix)
	ld	a, -7 (ix)
	sub	a, #0x0c
	jr	C,00114$
00113$:
;../time.c:170: lastTime.tm_mon=month;
	ld	hl, #(_lastTime + 0x0004)
	ld	a, -7 (ix)
	ld	(hl), a
;../time.c:171: lastTime.tm_mday=epoch+1;
	ld	a, -4 (ix)
	inc	a
	ld	(#(_lastTime + 0x0003)),a
;../time.c:173: lastTime.tm_isdst=0;
	ld	hl, #(_lastTime + 0x000a)
	ld	(hl), #0x00
;../time.c:175: return &lastTime;
	ld	hl, #_lastTime
;../time.c:176: }
	ld	sp, ix
	pop	ix
	ret
;../time.c:179: time_t mktime(struct tm *timeptr) {
;	---------------------------------
; Function mktime
; ---------------------------------
_mktime::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-12
	add	hl, sp
	ld	sp, hl
;../time.c:180: int year=timeptr->tm_year+1900, month=timeptr->tm_mon, i;
	ld	a, 4 (ix)
	ld	-12 (ix), a
	ld	a, 5 (ix)
	ld	-11 (ix), a
	pop	hl
	push	hl
	ld	de, #0x0005
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x076c
	add	hl, bc
	ld	-10 (ix), l
	ld	-9 (ix), h
	pop	hl
	push	hl
	ld	de, #0x0004
	add	hl, de
	ld	a, (hl)
	ld	-8 (ix), a
	ld	-7 (ix), #0x00
;../time.c:183: CheckTime(timeptr);
	pop	hl
	push	hl
	push	hl
	call	_CheckTime
	pop	af
;../time.c:186: seconds= (year-1970)*(60*60*24L*365);
	ld	a, -10 (ix)
	add	a, #0x4e
	ld	c, a
	ld	a, -9 (ix)
	adc	a, #0xf8
	ld	b, a
	rla
	sbc	a, a
	ld	e, a
	ld	d, a
	push	de
	push	bc
	ld	hl, #0x01e1
	push	hl
	ld	hl, #0x3380
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;../time.c:189: for (i=1970; i<year; i++) {
	ld	-6 (ix), #0xb2
	ld	-5 (ix), #0x07
00110$:
	ld	a, -6 (ix)
	sub	a, -10 (ix)
	ld	a, -5 (ix)
	sbc	a, -9 (ix)
	jp	PO, 00154$
	xor	a, #0x80
00154$:
	jp	P, 00124$
;../time.c:190: if (LEAP_YEAR(i)) {
	ld	hl, #0x0004
	push	hl
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	call	__modsint
	pop	af
	pop	af
	ld	a, h
	or	a, l
	jr	NZ,00111$
;../time.c:191: seconds+= 60*60*24L;
	ld	a, -4 (ix)
	add	a, #0x80
	ld	-4 (ix), a
	ld	a, -3 (ix)
	adc	a, #0x51
	ld	-3 (ix), a
	ld	a, -2 (ix)
	adc	a, #0x01
	ld	-2 (ix), a
	jr	NC,00155$
	inc	-1 (ix)
00155$:
00111$:
;../time.c:189: for (i=1970; i<year; i++) {
	inc	-6 (ix)
	jr	NZ,00110$
	inc	-5 (ix)
	jr	00110$
00124$:
;../time.c:196: for (i=0; i<month; i++) {
	ld	hl, #0x0004
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	call	__modsint
	pop	af
	pop	af
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	de, #0x0000
00113$:
	ld	a, e
	sub	a, -8 (ix)
	ld	a, d
	sbc	a, -7 (ix)
	jp	PO, 00157$
	xor	a, #0x80
00157$:
	jp	P, 00108$
;../time.c:197: if (i==1 && LEAP_YEAR(year)) { 
	ld	a, e
	dec	a
	or	a, d
	jr	NZ,00105$
	ld	a, -5 (ix)
	or	a, -6 (ix)
	jr	NZ,00105$
;../time.c:198: seconds+= 60*60*24L*29;
	ld	a, -4 (ix)
	add	a, #0x80
	ld	-4 (ix), a
	ld	a, -3 (ix)
	adc	a, #0x3b
	ld	-3 (ix), a
	ld	a, -2 (ix)
	adc	a, #0x26
	ld	-2 (ix), a
	jr	NC,00114$
	inc	-1 (ix)
	jr	00114$
00105$:
;../time.c:200: seconds+= 60*60*24L*monthDays[i];
	ld	hl, #_monthDays
	add	hl, de
	ld	c, (hl)
	ld	b, #0x00
	ld	hl, #0x0000
	push	de
	push	hl
	push	bc
	ld	hl, #0x0001
	push	hl
	ld	hl, #0x5180
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, e
	ld	b, d
	pop	de
	ld	a, l
	add	a, -4 (ix)
	ld	-4 (ix), a
	ld	a, h
	adc	a, -3 (ix)
	ld	-3 (ix), a
	ld	a, c
	adc	a, -2 (ix)
	ld	-2 (ix), a
	ld	a, b
	adc	a, -1 (ix)
	ld	-1 (ix), a
00114$:
;../time.c:196: for (i=0; i<month; i++) {
	inc	de
	jr	00113$
00108$:
;../time.c:204: seconds+= (timeptr->tm_mday-1)*60*60*24L;
	pop	hl
	push	hl
	inc	hl
	inc	hl
	inc	hl
	ld	c, (hl)
	ld	b, #0x00
	dec	bc
	ld	a, b
	rla
	sbc	a, a
	ld	e, a
	ld	d, a
	push	de
	push	bc
	ld	hl, #0x0001
	push	hl
	ld	hl, #0x5180
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, l
	add	a, -4 (ix)
	ld	-8 (ix), a
	ld	a, h
	adc	a, -3 (ix)
	ld	-7 (ix), a
	ld	a, e
	adc	a, -2 (ix)
	ld	-6 (ix), a
	ld	a, d
	adc	a, -1 (ix)
	ld	-5 (ix), a
;../time.c:205: seconds+= timeptr->tm_hour*60*60L;
	pop	hl
	push	hl
	inc	hl
	inc	hl
	ld	c, (hl)
	ld	b, #0x00
	ld	de, #0x0000
	push	de
	push	bc
	ld	hl, #0x0000
	push	hl
	ld	hl, #0x0e10
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	a, -8 (ix)
	add	a, l
	ld	-4 (ix), a
	ld	a, -7 (ix)
	adc	a, h
	ld	-3 (ix), a
	ld	a, -6 (ix)
	adc	a, e
	ld	-2 (ix), a
	ld	a, -5 (ix)
	adc	a, d
	ld	-1 (ix), a
;../time.c:206: seconds+= timeptr->tm_min*60;
	pop	hl
	push	hl
	inc	hl
	ld	c, (hl)
	ld	b, #0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	ld	a, h
	rla
	sbc	a, a
	ld	c, a
	ld	b, a
	ld	a, -4 (ix)
	add	a, l
	ld	e, a
	ld	a, -3 (ix)
	adc	a, h
	ld	d, a
	ld	a, -2 (ix)
	adc	a, c
	ld	c, a
	ld	a, -1 (ix)
	adc	a, b
	ld	b, a
;../time.c:207: seconds+= timeptr->tm_sec;
	pop	hl
	push	hl
	ld	l, (hl)
	ld	h, #0x00
	ld	-4 (ix), l
	ld	a, h
	ld	-3 (ix), a
	rla
	sbc	a, a
	ld	-2 (ix), a
	ld	-1 (ix), a
	ld	a, e
	add	a, -4 (ix)
	ld	l, a
	ld	a, d
	adc	a, -3 (ix)
	ld	h, a
	ld	a, c
	adc	a, -2 (ix)
	ld	e, a
	ld	a, b
	adc	a, -1 (ix)
	ld	d, a
;../time.c:208: return seconds;
;../time.c:209: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
