.module tasking_helpers
.globl _tasking_switch_to_task
.globl _ppmem_map
_tasking_switch_to_task:
push af     ; Push all registers
push bc
push de
push hl
push ix
push iy
ld hl,#0    ;Load HL with the stack pointer
add hl,sp
ld bc,#14   ;Add 14 to HL
add hl,bc
ld e,(hl)  ;Load ix with the address of the current task
inc hl
ld d,(hl)  ;Load ix with the address of the current task
ld ix,#0
add ix,de
ld hl,#0    ;Load HL with the stack pointer
add hl,sp
ld 8(ix),l  ; Store the stack pointer in the pc_or_sp field of the current task
ld 9(ix),h

ld bc,#16   ;Add 16 to HL
add hl,bc
ld e,(hl)  ;Load ix with the address of the next task
inc hl
ld d,(hl)  ;Load ix with the address of the next task
ld ix,#0
add ix,de
ld a,10(ix) ; Load a with the flags byte
and #0x1
cp #0x1
jp Z,end
ld l,8(ix)
ld h,9(ix)
ld sp,hl
end:
; ld a,#1
; push af
; ld hl,(ix)
; push hl
; call _ppmem_map
; ld a,h
; cp #0xFF
; jp Z,error_halt
; ld a,l
; out (0),a
; ld a,#1
; push af
; ld hl,2(ix)
; push hl
; call _ppmem_map
; ld a,h
; cp #0xFF
; jp Z,error_halt
; ld a,l
; out (1),a
; ld a,#1
; push af
; ld hl,4(ix)
; push hl
; call _ppmem_map
; ld a,h
; cp #0xFF
; jp Z,error_halt
; ld a,l
; out (2),a
ld a,10(ix) ; Load a with the flags byte
and #0x1
cp #0x1
jp NZ,end2
ld l,8(ix)
ld h,9(ix)
jp (hl)
end2:
ret
error_halt:
halt
