;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module _atof
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _atoi
	.globl _toupper
	.globl _isspace
	.globl _atof
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../_atof.c:33: float atof(const char * s)
;	---------------------------------
; Function atof
; ---------------------------------
_atof::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-12
	add	hl, sp
	ld	sp, hl
;../_atof.c:40: while (isspace(*s)) s++;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
00101$:
	ld	a, (bc)
	ld	e, a
	ld	d, #0x00
	push	bc
	push	de
	call	_isspace
	pop	af
	pop	bc
	ld	e, c
	ld	d, b
	inc	de
	ld	a, h
	or	a, l
	jr	Z,00155$
	ld	c, e
	ld	b, d
	jr	00101$
00155$:
	ld	4 (ix), c
	ld	5 (ix), b
;../_atof.c:43: if (*s == '-')
	ld	a, (bc)
	ld	b,a
	sub	a, #0x2d
	jr	NZ,00107$
;../_atof.c:45: sign=1;
	ld	c, #0x01
;../_atof.c:46: s++;
	ld	4 (ix), e
	ld	5 (ix), d
	jr	00108$
00107$:
;../_atof.c:50: sign=0;
	ld	c, #0x00
;../_atof.c:51: if (*s == '+') s++;
	ld	a, b
	sub	a, #0x2b
	jr	NZ,00108$
	ld	4 (ix), e
	ld	5 (ix), d
00108$:
;../_atof.c:55: for (value=0.0; isdigit(*s); s++)
	ld	-4 (ix), #0x00
	ld	-3 (ix), #0x00
	ld	-2 (ix), #0x00
	ld	-1 (ix), #0x00
	ld	e, 4 (ix)
	ld	d, 5 (ix)
00126$:
	ld	a, (de)
	ld	b, a
	ld	-5 (ix), b
	ld	hl, #0x0001
	add	hl, de
	ld	-10 (ix), l
	ld	-9 (ix), h
;./../../include/ctype.h:62: return ((unsigned char)c >= '0' && (unsigned char)c <= '9');
	ld	a, -5 (ix)
	sub	a, #0x30
	jr	C,00156$
	ld	a, #0x39
	sub	a, -5 (ix)
	jr	C,00156$
;../_atof.c:57: value=10.0*value+(*s-'0');
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	hl, #0x4120
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	pop	bc
	ld	d, #0x00
	ld	a, b
	add	a, #0xd0
	ld	e, a
	ld	a, d
	adc	a, #0xff
	ld	d, a
	push	bc
	push	de
	call	___sint2fs
	pop	af
	ex	de, hl
	push	hl
	push	de
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;../_atof.c:55: for (value=0.0; isdigit(*s); s++)
	ld	e, -10 (ix)
	ld	d, -9 (ix)
	jp	00126$
00156$:
	ld	4 (ix), e
	ld	5 (ix), d
;../_atof.c:61: if (*s == '.')
	ld	a, b
	sub	a, #0x2e
	jp	NZ,00112$
;../_atof.c:64: for (fraction=0.1; isdigit(*s); s++)
	ld	-8 (ix), #0xcd
	ld	-7 (ix), #0xcc
	ld	-6 (ix), #0xcc
	ld	-5 (ix), #0x3d
	ld	b, -10 (ix)
	ld	e, -9 (ix)
00129$:
	ld	l, b
	ld	h, e
	ld	l, (hl)
;./../../include/ctype.h:62: return ((unsigned char)c >= '0' && (unsigned char)c <= '9');
	ld	-9 (ix), l
	ld	a, l
	sub	a, #0x30
	jp	C, 00157$
	ld	a, #0x39
	sub	a, -9 (ix)
	jp	C, 00157$
;../_atof.c:66: value+=(*s-'0')*fraction;
	ld	h, #0x00
	ld	a, l
	add	a, #0xd0
	ld	l, a
	ld	a, h
	adc	a, #0xff
	ld	h, a
	push	bc
	push	de
	push	hl
	call	___sint2fs
	pop	af
	ld	-12 (ix), l
	ld	-11 (ix), h
	ld	-10 (ix), e
	ld	-9 (ix), d
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	l, -10 (ix)
	ld	h, -9 (ix)
	push	hl
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-12 (ix), l
	ld	-11 (ix), h
	ld	-10 (ix), e
	ld	-9 (ix), d
	push	de
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	push	hl
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	call	___fsadd
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	push	hl
	ld	l, -8 (ix)
	ld	h, -7 (ix)
	push	hl
	ld	hl, #0x3dcc
	push	hl
	ld	hl, #0xcccd
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	ld	-8 (ix), l
	ld	-7 (ix), h
	ld	-6 (ix), e
	ld	-5 (ix), d
	pop	de
	pop	bc
;../_atof.c:64: for (fraction=0.1; isdigit(*s); s++)
	inc	b
	jp	NZ,00129$
	inc	e
	jp	00129$
00157$:
	ld	4 (ix), b
	ld	5 (ix), e
00112$:
;../_atof.c:72: if (toupper(*s)=='E')
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	l, -6 (ix)
	ld	h, -5 (ix)
	ld	e, (hl)
	ld	d, #0x00
	push	bc
	push	de
	call	_toupper
	pop	af
	pop	bc
	ld	a, l
	sub	a, #0x45
	or	a, h
	jp	NZ,00120$
;../_atof.c:74: s++;
	ld	a, -6 (ix)
	add	a, #0x01
	ld	4 (ix), a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	5 (ix), a
;../_atof.c:75: iexp=(signed char)atoi(s);
	push	bc
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_atoi
	pop	af
	pop	bc
	ld	b, l
;../_atof.c:77: while(iexp!=0)
00116$:
	ld	a, b
	or	a, a
	jr	Z,00120$
;../_atof.c:79: if(iexp<0)
	bit	7, b
	jr	Z,00114$
;../_atof.c:81: value*=0.1;
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	hl, #0x3dcc
	push	hl
	ld	hl, #0xcccd
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;../_atof.c:82: iexp++;
	inc	b
	jr	00116$
00114$:
;../_atof.c:86: value*=10.0;
	push	bc
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	push	hl
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	push	hl
	ld	hl, #0x4120
	push	hl
	ld	hl, #0x0000
	push	hl
	call	___fsmul
	pop	af
	pop	af
	pop	af
	pop	af
	pop	bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	-2 (ix), e
	ld	-1 (ix), d
;../_atof.c:87: iexp--;
	dec	b
	jr	00116$
00120$:
;../_atof.c:93: if(sign) value*=-1.0;
	bit	0, c
	jr	Z,00122$
	ld	a, -1 (ix)
	xor	a,#0x80
	ld	-1 (ix), a
00122$:
;../_atof.c:94: return (value);
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	e, -2 (ix)
	ld	d, -1 (ix)
;../_atof.c:95: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
