;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module _divslonglong
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl __divslonglong
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
;../_divslonglong.c:36: _divslonglong (long long numerator, long long denominator)
;	---------------------------------
; Function _divslonglong
; ---------------------------------
__divslonglong::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-16
	add	hl, sp
	ld	sp, hl
;../_divslonglong.c:38: bool numeratorneg = (numerator < 0);
	ld	a, 13 (ix)
	rlca
	and	a,#0x01
	ld	c, a
;../_divslonglong.c:39: bool denominatorneg = (denominator < 0);
	ld	a, 21 (ix)
	rlca
	and	a,#0x01
	ld	b, a
;../_divslonglong.c:42: if (numeratorneg)
	bit	0, c
	jr	Z,00102$
;../_divslonglong.c:43: numerator = -numerator;
	xor	a, a
	sub	a, 6 (ix)
	ld	6 (ix), a
	ld	a, #0x00
	sbc	a, 7 (ix)
	ld	7 (ix), a
	ld	a, #0x00
	sbc	a, 8 (ix)
	ld	8 (ix), a
	ld	a, #0x00
	sbc	a, 9 (ix)
	ld	9 (ix), a
	ld	a, #0x00
	sbc	a, 10 (ix)
	ld	10 (ix), a
	ld	a, #0x00
	sbc	a, 11 (ix)
	ld	11 (ix), a
	ld	a, #0x00
	sbc	a, 12 (ix)
	ld	12 (ix), a
	ld	a, #0x00
	sbc	a, 13 (ix)
	ld	13 (ix), a
00102$:
;../_divslonglong.c:44: if (denominatorneg)
	bit	0, b
	jr	Z,00104$
;../_divslonglong.c:45: denominator = -denominator;
	xor	a, a
	sub	a, 14 (ix)
	ld	14 (ix), a
	ld	a, #0x00
	sbc	a, 15 (ix)
	ld	15 (ix), a
	ld	a, #0x00
	sbc	a, 16 (ix)
	ld	16 (ix), a
	ld	a, #0x00
	sbc	a, 17 (ix)
	ld	17 (ix), a
	ld	a, #0x00
	sbc	a, 18 (ix)
	ld	18 (ix), a
	ld	a, #0x00
	sbc	a, 19 (ix)
	ld	19 (ix), a
	ld	a, #0x00
	sbc	a, 20 (ix)
	ld	20 (ix), a
	ld	a, #0x00
	sbc	a, 21 (ix)
	ld	21 (ix), a
00104$:
;../_divslonglong.c:47: d = (unsigned long long)numerator / (unsigned long long)denominator;
	push	bc
	ld	hl, #2
	add	hl, sp
	ex	de, hl
	ld	hl, #24
	add	hl, sp
	ld	bc, #8
	ldir
	ld	hl, #10
	add	hl, sp
	ex	de, hl
	ld	hl, #32
	add	hl, sp
	ld	bc, #8
	ldir
	ld	e, -2 (ix)
	ld	d, -1 (ix)
	push	de
	ld	e, -4 (ix)
	ld	d, -3 (ix)
	push	de
	ld	e, -6 (ix)
	ld	d, -5 (ix)
	push	de
	ld	e, -8 (ix)
	ld	d, -7 (ix)
	push	de
	ld	e, -10 (ix)
	ld	d, -9 (ix)
	push	de
	ld	e, -12 (ix)
	ld	d, -11 (ix)
	push	de
	ld	e, -14 (ix)
	ld	d, -13 (ix)
	push	de
	ld	e, -16 (ix)
	ld	d, -15 (ix)
	push	de
	ld	hl, #0x001a
	add	hl, sp
	push	hl
	call	__divulonglong
	ld	hl, #18
	add	hl, sp
	ld	sp, hl
	ld	hl, #2
	add	hl, sp
	ex	de, hl
	ld	hl, #10
	add	hl, sp
	ld	bc, #8
	ldir
	pop	bc
;../_divslonglong.c:49: return ((numeratorneg ^ denominatorneg) ? -d : d);
	ld	a, c
	xor	a, b
	bit	0, a
	jr	Z,00107$
	xor	a, a
	sub	a, -16 (ix)
	ld	-8 (ix), a
	ld	a, #0x00
	sbc	a, -15 (ix)
	ld	-7 (ix), a
	ld	a, #0x00
	sbc	a, -14 (ix)
	ld	-6 (ix), a
	ld	a, #0x00
	sbc	a, -13 (ix)
	ld	-5 (ix), a
	ld	a, #0x00
	sbc	a, -12 (ix)
	ld	-4 (ix), a
	ld	a, #0x00
	sbc	a, -11 (ix)
	ld	-3 (ix), a
	ld	a, #0x00
	sbc	a, -10 (ix)
	ld	-2 (ix), a
	ld	a, #0x00
	sbc	a, -9 (ix)
	ld	-1 (ix), a
	jr	00108$
00107$:
	ld	hl, #8
	add	hl, sp
	ex	de, hl
	ld	hl, #0
	add	hl, sp
	ld	bc, #8
	ldir
00108$:
	ld	hl, #20
	add	hl, sp
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #8
	add	hl, sp
	ld	bc, #8
	ldir
;../_divslonglong.c:50: }
	ld	sp, ix
	pop	ix
	ret
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
