;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module c16rtomb
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _wctomb
	.globl _c16rtomb
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_c16rtomb_sps_65536_36:
	.ds 3
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../c16rtomb.c:35: size_t c16rtomb(char *restrict s, char16_t c16, mbstate_t *restrict ps)
;	---------------------------------
; Function c16rtomb
; ---------------------------------
_c16rtomb::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;../c16rtomb.c:41: if(!s)
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	NZ,00102$
;../c16rtomb.c:42: s = buf;
	ld	hl, #0
	add	hl, sp
	ld	4 (ix), l
	ld	5 (ix), h
00102$:
;../c16rtomb.c:44: if(!ps)
	ld	a, 9 (ix)
	or	a, 8 (ix)
	jr	NZ,00104$
;../c16rtomb.c:45: ps = &sps;
	ld	8 (ix), #<(_c16rtomb_sps_65536_36)
	ld	9 (ix), #>(_c16rtomb_sps_65536_36)
00104$:
;../c16rtomb.c:49: ps->c[1] = ps->c[2] = 0;
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	ld	c, e
	ld	b, d
	inc	bc
	inc	de
	inc	de
;../c16rtomb.c:47: if (!c16) // 0 always resets conversion state.
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	NZ,00119$
;../c16rtomb.c:49: ps->c[1] = ps->c[2] = 0;
	xor	a, a
	ld	(de), a
	xor	a, a
	ld	(bc), a
;../c16rtomb.c:50: codepoint = 0;
	ld	bc, #0x0000
	ld	de, #0x0000
	jp	00120$
00119$:
;../c16rtomb.c:52: else if(ps->c[1] || ps->c[2]) // We already have the high surrogate. Now get the low surrogate
	ld	a, (bc)
	ld	-1 (ix), a
	or	a, a
	jr	NZ,00114$
	ld	a, (de)
	or	a, a
	jr	Z,00115$
00114$:
;../c16rtomb.c:56: if(c16 < 0xdc00 || c16 > 0xdfff)
	ld	a, 7 (ix)
	sub	a, #0xdc
	jp	C, 00121$
	ld	a, #0xff
	cp	a, 6 (ix)
	ld	a, #0xdf
	sbc	a, 7 (ix)
	jp	C, 00121$
;../c16rtomb.c:59: high_surrogate = ps->c[1] + (ps->c[2] << 8);
	ld	a, -1 (ix)
	ld	-2 (ix), a
	ld	-1 (ix), #0x00
	ld	a, (de)
	ld	l, a
	ld	a, #0x00
	add	a, -2 (ix)
	ld	h, a
	ld	a, l
	adc	a, -1 (ix)
	ld	l, a
	ld	-2 (ix), h
	ld	-1 (ix), l
;../c16rtomb.c:60: ps->c[1] = ps->c[2] = 0;
	xor	a, a
	ld	(de), a
	xor	a, a
	ld	(bc), a
;../c16rtomb.c:61: codepoint = (high_surrogate << 10) - (0xd800 << 10) + c16 - 0xdc00 + 0x10000;
	ld	a, -2 (ix)
	add	a, a
	add	a, a
	ld	b, a
	ld	c, #0x00
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	add	hl, bc
	ld	de, #0x0000
	ld	c, l
	ld	a, h
	add	a, #0x24
	ld	b, a
	jr	NC,00120$
	inc	de
	jr	00120$
00115$:
;../c16rtomb.c:63: else if(c16 < 0xd7ff || c16 >= 0xe000) // Basic multilingual plane.
	ld	a, 6 (ix)
	sub	a, #0xff
	ld	a, 7 (ix)
	sbc	a, #0xd7
	jr	C,00110$
	ld	a, 7 (ix)
	sub	a, #0xe0
	jr	C,00111$
00110$:
;../c16rtomb.c:64: codepoint = c16;
	ld	c, 6 (ix)
	ld	b, 7 (ix)
	ld	de, #0x0000
	jr	00120$
00111$:
;../c16rtomb.c:67: if(c16 > 0xdbff)
	ld	a, #0xff
	cp	a, 6 (ix)
	ld	a, #0xdb
	sbc	a, 7 (ix)
	jr	C,00121$
;../c16rtomb.c:70: ps->c[1] = c16 & 0xff;
	ld	a, 6 (ix)
	ld	(bc), a
;../c16rtomb.c:71: ps->c[2] = c16 >> 8;
	ld	a, 7 (ix)
	ld	(de), a
;../c16rtomb.c:72: return(0);
	ld	hl, #0x0000
	jr	00122$
00120$:
;../c16rtomb.c:75: return(wctomb(s, codepoint));
	push	de
	push	bc
	ld	l, 4 (ix)
	ld	h, 5 (ix)
	push	hl
	call	_wctomb
	pop	af
	pop	af
	pop	af
	jr	00122$
;../c16rtomb.c:77: eilseq:
00121$:
;../c16rtomb.c:78: errno = EILSEQ;
	ld	hl, #0x0054
	ld	(_errno), hl
;../c16rtomb.c:79: return(-1);
	ld	hl, #0xffff
00122$:
;../c16rtomb.c:80: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
