;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module mbrtowc
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _mbrtowc
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_mbrtowc_sps_65536_10:
	.ds 3
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../mbrtowc.c:32: size_t mbrtowc(wchar_t *restrict pwc, const char *restrict s, size_t n, mbstate_t *restrict ps)
;	---------------------------------
; Function mbrtowc
; ---------------------------------
_mbrtowc::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-20
	add	hl, sp
	ld	sp, hl
;../mbrtowc.c:41: if(!s)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	NZ,00102$
;../mbrtowc.c:42: return(mbrtowc(0, "", 1, ps));
	ld	l, 10 (ix)
	ld	h, 11 (ix)
	push	hl
	ld	hl, #0x0001
	push	hl
	ld	hl, #___str_0
	push	hl
	ld	hl, #0x0000
	push	hl
	call	_mbrtowc
	pop	af
	pop	af
	pop	af
	pop	af
	jp	00143$
00102$:
;../mbrtowc.c:43: if(!n)
	ld	a, 9 (ix)
	or	a, 8 (ix)
	jp	Z, 00126$
;../mbrtowc.c:45: if(!ps)
	ld	a, 11 (ix)
	or	a, 10 (ix)
	jr	NZ,00106$
;../mbrtowc.c:47: ps = &sps;
	ld	10 (ix), #<(_mbrtowc_sps_65536_10)
	ld	11 (ix), #>(_mbrtowc_sps_65536_10)
00106$:
;../mbrtowc.c:50: for(i = 0; ps->c[i] && i < 3; i++)
	ld	hl, #0
	add	hl, sp
	ld	-16 (ix), l
	ld	-15 (ix), h
	ld	a, 10 (ix)
	ld	-14 (ix), a
	ld	a, 11 (ix)
	ld	-13 (ix), a
	ld	a, -14 (ix)
	ld	-6 (ix), a
	ld	a, -13 (ix)
	ld	-5 (ix), a
	ld	-1 (ix), #0x00
00129$:
	ld	a, -6 (ix)
	add	a, -1 (ix)
	ld	-3 (ix), a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	ld	a, (hl)
	ld	-4 (ix), a
	or	a, a
	jr	Z,00171$
	ld	a, -1 (ix)
	sub	a, #0x03
	jr	NC,00171$
;../mbrtowc.c:51: mbseq[i] = ps->c[i];
	ld	a, -16 (ix)
	add	a, -1 (ix)
	ld	-3 (ix), a
	ld	a, -15 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	ld	a, -4 (ix)
	ld	(hl), a
;../mbrtowc.c:50: for(i = 0; ps->c[i] && i < 3; i++)
	inc	-1 (ix)
	jr	00129$
00171$:
	ld	a, -1 (ix)
	ld	-12 (ix), a
;../mbrtowc.c:53: seqlen = 1;
	ld	-2 (ix), #0x01
;../mbrtowc.c:54: first_byte = ps->c[0] ? ps->c[0] : *s;
	ld	a, 10 (ix)
	ld	-4 (ix), a
	ld	a, 11 (ix)
	ld	-3 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	ld	-1 (ix), a
	ld	a, 6 (ix)
	ld	-11 (ix), a
	ld	a, 7 (ix)
	ld	-10 (ix), a
	ld	a, -1 (ix)
	or	a, a
	jr	NZ,00146$
	ld	l, -11 (ix)
	ld	h, -10 (ix)
	ld	a, (hl)
	ld	-1 (ix), a
00146$:
;../mbrtowc.c:56: if(first_byte & 0x80)
	bit	7, -1 (ix)
	jr	Z,00112$
;../mbrtowc.c:58: while (first_byte & (0x80 >> seqlen))
	ld	-9 (ix), #0x01
00108$:
	ld	b, -9 (ix)
	ld	-8 (ix), #0x80
	ld	-7 (ix), #0x00
	inc	b
	jr	00274$
00273$:
	sra	-7 (ix)
	rr	-8 (ix)
00274$:
	djnz	00273$
	ld	a, -1 (ix)
	ld	-6 (ix), a
	ld	-5 (ix), #0x00
;../mbrtowc.c:59: seqlen++;
	ld	a, -9 (ix)
	inc	a
	ld	-4 (ix), a
;../mbrtowc.c:58: while (first_byte & (0x80 >> seqlen))
	ld	a, -6 (ix)
	and	a, -8 (ix)
	ld	-3 (ix), a
	ld	a, -5 (ix)
	and	a, -7 (ix)
	ld	-2 (ix), a
	or	a, -3 (ix)
	jr	Z,00172$
;../mbrtowc.c:59: seqlen++;
	ld	a, -4 (ix)
	ld	-9 (ix), a
	jr	00108$
00172$:
	ld	a, -9 (ix)
	ld	-2 (ix), a
;../mbrtowc.c:60: first_byte &= (0xff >> (seqlen + 1));
	ld	b, -4 (ix)
	ld	-7 (ix), #0xff
	ld	-6 (ix), #0x00
	inc	b
	jr	00276$
00275$:
	sra	-6 (ix)
	rr	-7 (ix)
00276$:
	djnz	00275$
	ld	a, -7 (ix)
	and	a, -1 (ix)
	ld	-1 (ix), a
00112$:
;../mbrtowc.c:63: if(seqlen > 4)
	ld	a, #0x04
	sub	a, -2 (ix)
	jp	C, 00126$
;../mbrtowc.c:66: if(i + n < seqlen) // Incomplete multibyte character
	ld	a, -12 (ix)
	ld	-4 (ix), a
	ld	-3 (ix), #0x00
	ld	c, a
	ld	b, #0x00
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	add	hl, bc
	ld	c, -2 (ix)
	ld	b, #0x00
	cp	a, a
	sbc	hl, bc
	jp	NC, 00162$
;../mbrtowc.c:70: return(-2);
	ld	a, -14 (ix)
	ld	-4 (ix), a
	ld	a, -13 (ix)
	ld	-3 (ix), a
	ld	a, -11 (ix)
	ld	-2 (ix), a
	ld	a, -10 (ix)
	ld	-1 (ix), a
	ld	a, -12 (ix)
	ld	-5 (ix), a
	ld	a, 8 (ix)
	ld	-7 (ix), a
	ld	a, 9 (ix)
	ld	-6 (ix), a
00132$:
;../mbrtowc.c:68: for(;n-- ; i++)
	ld	a, -7 (ix)
	ld	-9 (ix), a
	ld	a, -6 (ix)
	ld	-8 (ix), a
	ld	l, -7 (ix)
	ld	h, -6 (ix)
	dec	hl
	ld	-7 (ix), l
	ld	-6 (ix), h
	ld	a, -8 (ix)
	or	a, -9 (ix)
	jr	Z,00115$
;../mbrtowc.c:69: ps->c[i] = *s++;
	ld	a, -5 (ix)
	add	a, -4 (ix)
	ld	-9 (ix), a
	ld	a, #0x00
	adc	a, -3 (ix)
	ld	-8 (ix), a
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	a, (hl)
	inc	-2 (ix)
	jr	NZ,00277$
	inc	-1 (ix)
00277$:
	ld	l, -9 (ix)
	ld	h, -8 (ix)
	ld	(hl), a
;../mbrtowc.c:68: for(;n-- ; i++)
	inc	-5 (ix)
	jr	00132$
00115$:
;../mbrtowc.c:70: return(-2);
	ld	hl, #0xfffe
	jp	00143$
;../mbrtowc.c:73: for(j = 0; j < i; j++)
00162$:
	ld	c, -14 (ix)
	ld	b, -13 (ix)
	ld	e, #0x00
00135$:
	ld	a, e
	sub	a, -12 (ix)
	jr	NC,00118$
;../mbrtowc.c:74: ps->c[j] = 0;
	ld	l, e
	ld	h, #0x00
	add	hl, bc
	ld	(hl), #0x00
;../mbrtowc.c:73: for(j = 0; j < i; j++)
	inc	e
	jr	00135$
00118$:
;../mbrtowc.c:76: for(n = 1, i = i ? i : 1; i < seqlen; i++, n++)
	ld	8 (ix), #0x01
	ld	9 (ix), #0x00
	ld	a, -12 (ix)
	or	a, a
	jr	NZ,00148$
	ld	-4 (ix), #0x01
	ld	-3 (ix), #0x00
00148$:
	ld	a, -4 (ix)
	ld	-5 (ix), a
	ld	a, -16 (ix)
	ld	-9 (ix), a
	ld	a, -15 (ix)
	ld	-8 (ix), a
	ld	a, -11 (ix)
	ld	-4 (ix), a
	ld	a, -10 (ix)
	ld	-3 (ix), a
	ld	-7 (ix), #0x01
	ld	-6 (ix), #0x00
00138$:
	ld	a, -5 (ix)
	sub	a, -2 (ix)
	jr	NC,00121$
;../mbrtowc.c:78: mbseq[i] = *s++;
	ld	a, -5 (ix)
	add	a, -9 (ix)
	ld	-12 (ix), a
	ld	a, #0x00
	adc	a, -8 (ix)
	ld	-11 (ix), a
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, (hl)
	ld	-10 (ix), a
	inc	-4 (ix)
	jr	NZ,00278$
	inc	-3 (ix)
00278$:
	ld	l, -12 (ix)
	ld	h, -11 (ix)
	ld	a, -10 (ix)
	ld	(hl), a
;../mbrtowc.c:79: if((mbseq[i] & 0xc0) != 0x80)
	ld	a, -10 (ix)
	ld	-13 (ix), a
	ld	-12 (ix), #0x00
	ld	a, -13 (ix)
	and	a, #0xc0
	ld	-11 (ix), a
	ld	-10 (ix), #0x00
	ld	a, -11 (ix)
	sub	a, #0x80
	or	a, -10 (ix)
	jp	NZ,00126$
;../mbrtowc.c:76: for(n = 1, i = i ? i : 1; i < seqlen; i++, n++)
	inc	-5 (ix)
	inc	-7 (ix)
	jr	NZ,00281$
	inc	-6 (ix)
00281$:
	ld	a, -7 (ix)
	ld	8 (ix), a
	ld	a, -6 (ix)
	ld	9 (ix), a
	jr	00138$
00121$:
;../mbrtowc.c:83: codepoint = first_byte;
	ld	a, -1 (ix)
	ld	-6 (ix), a
	ld	-5 (ix), #0x00
	ld	-4 (ix), #0x00
	ld	-3 (ix), #0x00
;../mbrtowc.c:85: for(s = mbseq + 1, seqlen--; seqlen; seqlen--)
	ld	l, -16 (ix)
	ld	h, -15 (ix)
	inc	hl
	ld	a, -2 (ix)
	add	a, #0xff
	ld	-1 (ix), a
00141$:
	ld	a, -1 (ix)
	or	a, a
	jr	Z,00122$
;../mbrtowc.c:87: codepoint <<= 6;
	ld	c, -6 (ix)
	ld	b, -5 (ix)
	ld	e, -4 (ix)
	ld	d, -3 (ix)
	ld	a, #0x06
00282$:
	sla	c
	rl	b
	rl	e
	rl	d
	dec	a
	jr	NZ,00282$
;../mbrtowc.c:88: codepoint |= (*s & 0x3f);
	ld	a, (hl)
	ld	-5 (ix), a
	ld	-4 (ix), #0x00
	ld	a, -5 (ix)
	and	a, #0x3f
	ld	-3 (ix), a
	ld	-2 (ix), #0x00
	ld	a, -3 (ix)
	ld	-10 (ix), a
	ld	a, -2 (ix)
	ld	-9 (ix), a
	rla
	sbc	a, a
	ld	-8 (ix), a
	ld	-7 (ix), a
	ld	a, c
	or	a, -10 (ix)
	ld	-6 (ix), a
	ld	a, b
	or	a, -9 (ix)
	ld	-5 (ix), a
	ld	a, e
	or	a, -8 (ix)
	ld	-4 (ix), a
	ld	a, d
	or	a, -7 (ix)
	ld	-3 (ix), a
;../mbrtowc.c:89: s++;
	inc	hl
;../mbrtowc.c:85: for(s = mbseq + 1, seqlen--; seqlen; seqlen--)
	dec	-1 (ix)
	jr	00141$
00122$:
;../mbrtowc.c:92: if(codepoint >= 0xd800 && codepoint <= 0xdfff) // UTF-16 surrogate.
	ld	a, -5 (ix)
	sub	a, #0xd8
	ld	a, -4 (ix)
	sbc	a, #0x00
	ld	a, -3 (ix)
	sbc	a, #0x00
	jr	C,00124$
	ld	a, #0xff
	cp	a, -6 (ix)
	ld	a, #0xdf
	sbc	a, -5 (ix)
	ld	a, #0x00
	sbc	a, -4 (ix)
	ld	a, #0x00
	sbc	a, -3 (ix)
	jr	C,00124$
;../mbrtowc.c:93: return(-1);
	ld	hl, #0xffff
	jr	00143$
00124$:
;../mbrtowc.c:95: *pwc = codepoint;
	ld	e, 4 (ix)
	ld	d, 5 (ix)
	ld	hl, #0x000e
	add	hl, sp
	ld	bc, #0x0004
	ldir
;../mbrtowc.c:96: return(n);
	ld	l, 8 (ix)
	ld	h, 9 (ix)
	jr	00143$
;../mbrtowc.c:98: eilseq:
00126$:
;../mbrtowc.c:99: errno = EILSEQ;
	ld	hl, #0x0054
	ld	(_errno), hl
;../mbrtowc.c:100: return(-1);
	ld	hl, #0xffff
00143$:
;../mbrtowc.c:101: }
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
