;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module strtoul
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _strncmp
	.globl _strtoul
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../strtoul.c:37: static signed char _isdigit(const char c, unsigned char base)
;	---------------------------------
; Function _isdigit
; ---------------------------------
__isdigit:
	push	ix
	ld	ix,#0
	add	ix,sp
;../strtoul.c:42: v = c - '0';
	ld	c, 4 (ix)
;../strtoul.c:41: if (c >= '0' && c <= '9')
	ld	a, 4 (ix)
	sub	a, #0x30
	jr	C,00110$
	ld	a, #0x39
	sub	a, 4 (ix)
	jr	C,00110$
;../strtoul.c:42: v = c - '0';
	ld	a, c
	add	a, #0xd0
	ld	l, a
	jr	00111$
00110$:
;../strtoul.c:43: else if (c >= 'a' && c <='z')
	ld	a, 4 (ix)
	sub	a, #0x61
	jr	C,00106$
	ld	a, #0x7a
	sub	a, 4 (ix)
	jr	C,00106$
;../strtoul.c:44: v = c - 'a' + 10;
	ld	a, c
	add	a, #0xa9
	ld	l, a
	jr	00111$
00106$:
;../strtoul.c:45: else if (c >= 'A' && c <='Z')
	ld	a, 4 (ix)
	sub	a, #0x41
	jr	C,00102$
	ld	a, #0x5a
	sub	a, 4 (ix)
	jr	C,00102$
;../strtoul.c:46: v = c - 'A' + 10;
	ld	a, c
	add	a, #0xc9
	ld	l, a
	jr	00111$
00102$:
;../strtoul.c:48: return (-1);
	ld	l, #0xff
	jr	00115$
00111$:
;../strtoul.c:50: if (v >= base)
	ld	a, l
	sub	a, 5 (ix)
	jr	C,00114$
;../strtoul.c:51: return (-1);
	ld	l, #0xff
;../strtoul.c:53: return (v);
00114$:
00115$:
;../strtoul.c:54: }
	pop	ix
	ret
;../strtoul.c:56: unsigned long int strtoul(const char *nptr, char **endptr, int base)
;	---------------------------------
; Function strtoul
; ---------------------------------
_strtoul::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-18
	add	hl, sp
	ld	sp, hl
;../strtoul.c:58: const char *ptr = nptr;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
;../strtoul.c:60: bool range_error = false;
	ld	-18 (ix), #0x00
;../strtoul.c:61: bool neg = false;
	ld	-17 (ix), #0x00
;../strtoul.c:63: while (isblank (*ptr))
00101$:
	ld	a, (bc)
	ld	-1 (ix), a
;./../../include/ctype.h:53: return ((unsigned char)c == ' ' || (unsigned char)c == '\t');
	cp	a, #0x20
	jr	Z,00140$
	sub	a, #0x09
	jr	NZ,00163$
00140$:
;../strtoul.c:64: ptr++;
	inc	bc
	jr	00101$
00163$:
;../strtoul.c:67: switch(*ptr)
	ld	a, -1 (ix)
	sub	a, #0x2b
	jr	Z,00105$
	ld	a, -1 (ix)
	sub	a, #0x2d
	jr	NZ,00106$
;../strtoul.c:70: neg = true;
	ld	-17 (ix), #0x01
;../strtoul.c:71: case '+':
00105$:
;../strtoul.c:72: ptr++;
	inc	bc
;../strtoul.c:73: }
00106$:
;../strtoul.c:81: ptr += 2;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
;../strtoul.c:76: if (!base)
	ld	a, 9 (ix)
	or	a, 8 (ix)
	jr	NZ,00119$
;../strtoul.c:78: if (!strncmp (ptr, "0x", 2) || !strncmp (ptr, "0X", 2))
	push	bc
	push	de
	ld	hl, #0x0002
	push	hl
	ld	hl, #___str_0
	push	hl
	push	bc
	call	_strncmp
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00110$
	push	bc
	push	de
	ld	hl, #0x0002
	push	hl
	ld	hl, #___str_1
	push	hl
	push	bc
	call	_strncmp
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00111$
00110$:
;../strtoul.c:80: base = 16;
	ld	8 (ix), #0x10
	ld	9 (ix), #0x00
;../strtoul.c:81: ptr += 2;
	ld	c, e
	ld	b, d
	jr	00120$
00111$:
;../strtoul.c:83: else if (*ptr == '0')
	ld	a, (bc)
	sub	a, #0x30
	jr	NZ,00108$
;../strtoul.c:85: base = 8;
	ld	8 (ix), #0x08
	ld	9 (ix), #0x00
;../strtoul.c:86: ptr++;
	inc	bc
	jr	00120$
00108$:
;../strtoul.c:89: base = 10;
	ld	8 (ix), #0x0a
	ld	9 (ix), #0x00
	jr	00120$
00119$:
;../strtoul.c:92: else if (base == 16 && (!strncmp (ptr, "0x", 2) || !strncmp (ptr, "0X", 2)))
	ld	a, 8 (ix)
	sub	a, #0x10
	or	a, 9 (ix)
	jr	NZ,00120$
	push	bc
	push	de
	ld	hl, #0x0002
	push	hl
	ld	hl, #___str_0
	push	hl
	push	bc
	call	_strncmp
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	Z,00114$
	push	bc
	push	de
	ld	hl, #0x0002
	push	hl
	ld	hl, #___str_1
	push	hl
	push	bc
	call	_strncmp
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
	ld	a, h
	or	a, l
	jr	NZ,00120$
00114$:
;../strtoul.c:93: ptr += 2;
	ld	c, e
	ld	b, d
00120$:
;../strtoul.c:97: if (_isdigit (*ptr, base) < 0)
	ld	a, 8 (ix)
	ld	-16 (ix), a
	ld	a, (bc)
	ld	d, a
	push	bc
	ld	a, -16 (ix)
	push	af
	inc	sp
	push	de
	inc	sp
	call	__isdigit
	pop	af
	pop	bc
;../strtoul.c:100: *endptr = (char*)nptr;
	ld	e, 6 (ix)
	ld	d, 7 (ix)
;../strtoul.c:97: if (_isdigit (*ptr, base) < 0)
	bit	7, l
	jr	Z,00124$
;../strtoul.c:99: if (endptr)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	Z,00122$
;../strtoul.c:100: *endptr = (char*)nptr;
	ld	a, 4 (ix)
	ld	(de), a
	inc	de
	ld	a, 5 (ix)
	ld	(de), a
00122$:
;../strtoul.c:101: return (0);
	ld	hl,#0x0000
	ld	e,l
	ld	d,h
	jp	00137$
00124$:
;../strtoul.c:104: for (ret = 0;; ptr++)
	xor	a, a
	ld	-15 (ix), a
	ld	-14 (ix), a
	ld	-13 (ix), a
	ld	-12 (ix), a
	ld	-2 (ix), c
	ld	-1 (ix), b
00135$:
;../strtoul.c:107: signed char digit = _isdigit (*ptr, base);
	ld	l, -2 (ix)
	ld	h, -1 (ix)
	ld	b, (hl)
	push	de
	ld	a, -16 (ix)
	push	af
	inc	sp
	push	bc
	inc	sp
	call	__isdigit
	pop	af
	pop	de
	ld	-11 (ix), l
;../strtoul.c:109: if (digit < 0)
	bit	7, -11 (ix)
	jp	NZ, 00129$
;../strtoul.c:112: oldret = ret;
	ld	a, -15 (ix)
	ld	-10 (ix), a
	ld	a, -14 (ix)
	ld	-9 (ix), a
	ld	a, -13 (ix)
	ld	-8 (ix), a
	ld	a, -12 (ix)
	ld	-7 (ix), a
;../strtoul.c:113: ret *= base;
	ld	c, 8 (ix)
	ld	a, 9 (ix)
	ld	b, a
	rla
	sbc	a, a
	ld	l, a
	ld	h, a
	push	de
	push	hl
	push	bc
	ld	l, -13 (ix)
	ld	h, -12 (ix)
	push	hl
	ld	l, -15 (ix)
	ld	h, -14 (ix)
	push	hl
	call	__mullong
	pop	af
	pop	af
	pop	af
	pop	af
	ld	c, e
	ld	b, d
	pop	de
	ld	-6 (ix), l
	ld	-5 (ix), h
	ld	-4 (ix), c
	ld	-3 (ix), b
;../strtoul.c:114: if (ret < oldret)
	ld	a, -6 (ix)
	sub	a, -10 (ix)
	ld	a, -5 (ix)
	sbc	a, -9 (ix)
	ld	a, -4 (ix)
	sbc	a, -8 (ix)
	ld	a, -3 (ix)
	sbc	a, -7 (ix)
	jr	NC,00128$
;../strtoul.c:115: range_error = true;
	ld	-18 (ix), #0x01
00128$:
;../strtoul.c:117: ret += (unsigned char)digit;
	ld	c, -11 (ix)
	ld	b, #0x00
	ld	hl, #0x0000
	ld	a, c
	add	a, -6 (ix)
	ld	-15 (ix), a
	ld	a, b
	adc	a, -5 (ix)
	ld	-14 (ix), a
	ld	a, l
	adc	a, -4 (ix)
	ld	-13 (ix), a
	ld	a, h
	adc	a, -3 (ix)
	ld	-12 (ix), a
;../strtoul.c:104: for (ret = 0;; ptr++)
	inc	-2 (ix)
	jp	NZ,00135$
	inc	-1 (ix)
	jp	00135$
00129$:
;../strtoul.c:120: if (endptr)
	ld	a, 7 (ix)
	or	a, 6 (ix)
	jr	Z,00131$
;../strtoul.c:121: *endptr = (char*)ptr;
	ld	a, -2 (ix)
	ld	(de), a
	inc	de
	ld	a, -1 (ix)
	ld	(de), a
00131$:
;../strtoul.c:123: if (range_error)
	bit	0, -18 (ix)
	jr	Z,00133$
;../strtoul.c:125: errno = ERANGE;
	ld	hl, #0x0022
	ld	(_errno), hl
;../strtoul.c:126: return (ULONG_MAX);
	ld	hl,#0xffff
	ld	e,l
	ld	d,h
	jr	00137$
00133$:
;../strtoul.c:129: return (neg ? -ret : ret);
	bit	0, -17 (ix)
	jr	Z,00142$
	xor	a, a
	sub	a, -15 (ix)
	ld	c, a
	ld	a, #0x00
	sbc	a, -14 (ix)
	ld	b, a
	ld	a, #0x00
	sbc	a, -13 (ix)
	ld	e, a
	ld	a, #0x00
	sbc	a, -12 (ix)
	ld	d, a
	jr	00143$
00142$:
	ld	c, -15 (ix)
	ld	b, -14 (ix)
	ld	e, -13 (ix)
	ld	d, -12 (ix)
00143$:
	ld	l, c
	ld	h, b
00137$:
;../strtoul.c:130: }
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "0x"
	.db 0x00
___str_1:
	.ascii "0X"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
