;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.9.0 #11195 (Mac OS X x86_64)
;--------------------------------------------------------
	.module wctomb
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _wctomb
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;../wctomb.c:31: int wctomb(char *s, wchar_t wc)
;	---------------------------------
; Function wctomb
; ---------------------------------
_wctomb::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-7
	add	hl, sp
	ld	sp, hl
;../wctomb.c:35: if(!s)
	ld	a, 5 (ix)
	or	a, 4 (ix)
	jr	NZ,00102$
;../wctomb.c:36: return(0);
	ld	hl, #0x0000
	jp	00119$
00102$:
;../wctomb.c:40: s[0] = wc;
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	e, 6 (ix)
;../wctomb.c:38: if(wc < 0x80)
	ld	a, 6 (ix)
	sub	a, #0x80
	ld	a, 7 (ix)
	sbc	a, #0x00
	ld	a, 8 (ix)
	sbc	a, #0x00
	ld	a, 9 (ix)
	sbc	a, #0x00
	jr	NC,00117$
;../wctomb.c:40: s[0] = wc;
	ld	a, e
	ld	(bc), a
;../wctomb.c:41: return(1);
	ld	hl, #0x0001
	jp	00119$
00117$:
;../wctomb.c:45: s[0] = (wc >> 6) & 0x1f | 0xc0;
	ld	l, 6 (ix)
	ld	h, 7 (ix)
	srl	h
	rr	l
	srl	h
	rr	l
	srl	h
	rr	l
	srl	h
	rr	l
	srl	h
	rr	l
	srl	h
	rr	l
;../wctomb.c:46: s[1] = (wc >> 0) & 0x3f | 0x80;
	ld	a, c
	add	a, #0x01
	ld	-7 (ix), a
	ld	a, b
	adc	a, #0x00
	ld	-6 (ix), a
	ld	a, e
	and	a, #0x3f
;../wctomb.c:45: s[0] = (wc >> 6) & 0x1f | 0xc0;
	ld	-1 (ix), l
;../wctomb.c:46: s[1] = (wc >> 0) & 0x3f | 0x80;
	or	a, #0x80
	ld	-5 (ix), a
;../wctomb.c:43: else if(wc < 0x800)
	ld	a, 7 (ix)
	sub	a, #0x08
	ld	a, 8 (ix)
	sbc	a, #0x00
	ld	a, 9 (ix)
	sbc	a, #0x00
	jr	NC,00114$
;../wctomb.c:45: s[0] = (wc >> 6) & 0x1f | 0xc0;
	ld	a, -1 (ix)
	and	a, #0x1f
	or	a, #0xc0
	ld	(bc), a
;../wctomb.c:46: s[1] = (wc >> 0) & 0x3f | 0x80;
	pop	hl
	push	hl
	ld	a, -5 (ix)
	ld	(hl), a
;../wctomb.c:47: return(2);
	ld	hl, #0x0002
	jp	00119$
00114$:
;../wctomb.c:49: else if(wc >= 0xd800 && wc < 0xe000) // Unpaired surrogate
	ld	a, 7 (ix)
	sub	a, #0xd8
	ld	a, 8 (ix)
	sbc	a, #0x00
	ld	a, 9 (ix)
	sbc	a, #0x00
	jr	C,00110$
	ld	a, 7 (ix)
	sub	a, #0xe0
	ld	a, 8 (ix)
	sbc	a, #0x00
	ld	a, 9 (ix)
	sbc	a, #0x00
	jr	NC,00110$
;../wctomb.c:50: return(-1);
	ld	hl, #0xffff
	jp	00119$
00110$:
;../wctomb.c:53: s[0] = (wc >> 12) & 0x0f | 0xe0;
	ld	e, 7 (ix)
	ld	d, 8 (ix)
	ld	l, 9 (ix)
	ld	a, #0x04
00156$:
	srl	l
	rr	d
	rr	e
	dec	a
	jr	NZ, 00156$
;../wctomb.c:55: s[2] = (wc >> 0) & 0x3f  | 0x80;
	ld	a, c
	add	a, #0x02
	ld	-4 (ix), a
	ld	a, b
	adc	a, #0x00
	ld	-3 (ix), a
;../wctomb.c:53: s[0] = (wc >> 12) & 0x0f | 0xe0;
	ld	-2 (ix), e
;../wctomb.c:54: s[1] = (wc >> 6) & 0x3f  | 0x80;
	ld	a, -1 (ix)
	and	a, #0x3f
	or	a, #0x80
	ld	-1 (ix), a
;../wctomb.c:51: else if(wc < 0x10000)
	ld	a, 8 (ix)
	sub	a, #0x01
	ld	a, 9 (ix)
	sbc	a, #0x00
	jr	NC,00107$
;../wctomb.c:53: s[0] = (wc >> 12) & 0x0f | 0xe0;
	ld	a, -2 (ix)
	and	a, #0x0f
	or	a, #0xe0
	ld	(bc), a
;../wctomb.c:54: s[1] = (wc >> 6) & 0x3f  | 0x80;
	pop	hl
	push	hl
	ld	a, -1 (ix)
	ld	(hl), a
;../wctomb.c:55: s[2] = (wc >> 0) & 0x3f  | 0x80;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, -5 (ix)
	ld	(hl), a
;../wctomb.c:56: return(3);
	ld	hl, #0x0003
	jr	00119$
00107$:
;../wctomb.c:58: else if(wc < 0x110000)
	ld	a, 8 (ix)
	sub	a, #0x11
	ld	a, 9 (ix)
	sbc	a, #0x00
	jr	NC,00104$
;../wctomb.c:60: s[0] = (wc >> 18) & 0x07 | 0xf0;
	ld	e, 8 (ix)
	ld	d, 9 (ix)
	ld	a, #0x02
00158$:
	srl	d
	rr	e
	dec	a
	jr	NZ, 00158$
	ld	a, e
	and	a, #0x07
	or	a, #0xf0
	ld	(bc), a
;../wctomb.c:61: s[1] = (wc >> 12) & 0x3f | 0x80;
	ld	a, -2 (ix)
	and	a, #0x3f
	set	7, a
	pop	hl
	push	hl
	ld	(hl), a
;../wctomb.c:62: s[2] = (wc >> 6) & 0x3f  | 0x80;
	ld	l, -4 (ix)
	ld	h, -3 (ix)
	ld	a, -1 (ix)
	ld	(hl), a
;../wctomb.c:63: s[3] = (wc >> 0) & 0x3f  | 0x80;
	inc	bc
	inc	bc
	inc	bc
	ld	h, b
	ld	l, c
	ld	a, -5 (ix)
	ld	(hl), a
;../wctomb.c:64: return(4);
	ld	hl, #0x0004
	jr	00119$
00104$:
;../wctomb.c:67: return(-1);
	ld	hl, #0xffff
00119$:
;../wctomb.c:68: }
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
